-- locale = "en";
-- fileSuffix = "";
-- if Turbine.Shell.IsCommand("hilfe") then
-- 	locale = "de";
-- 	fileSuffix = "__de";
-- elseif Turbine.Shell.IsCommand("aide") then
-- 	locale = "fr";
-- 	fileSuffix = "__fr";
-- end


resetPhrases = {}
resetPhrases["en"] = {}
resetPhrases["de"] = {}
resetPhrases["fr"] = {}

--EN
resetPhrases["en"][1] = "You have joined a Fellowship."
resetPhrases["en"][2] = "You have joined a Raid."

resetPhrases["en"][3] = "has joined your Fellowship."
resetPhrases["en"][4] = "has joined your Raid."

resetPhrases["en"][5] = "You dismiss "
resetPhrases["en"][6] = "You dismiss "

resetPhrases["en"][7] = " been dismissed from your Fellowship."
resetPhrases["en"][8] = " been dismissed from your Raid."

resetPhrases["en"][9]  = "has left your Fellowship."
resetPhrases["en"][10] = "has left your Raid."

resetPhrases["en"][11] = "You leave your Fellowship."
resetPhrases["en"][12] = "You leave your Raid."

--DE
resetPhrases["de"][1] = "Ihr habt Euch einer Gruppe von Gefährten angeschlossen."
resetPhrases["de"][2] = "Ihr verlasst Eure Gruppe von Gefährten."

resetPhrases["de"][3] = "hat sich Eurer Gruppe von Gefährten angeschlossen."
resetPhrases["de"][4] = "hat Eure Gruppe von Gefährten verlassen."

resetPhrases["de"][5] = "Ihr wurdet aus Eurer Gruppe von Gefährten ausgeschlossen."
resetPhrases["de"][6] = "wurde aus Eurer Gruppe von Gefährten ausgeschlossen."

resetPhrases["de"][7] = "wurde aus Eurem Schlachtzug ausgeschlossen."
resetPhrases["de"][8] = "Ihr wurdet aus Eurem Schlachtzug ausgeschlossen."

resetPhrases["de"][9] = "Ihr habt Euch einem Schlachtzug angeschlossen."
resetPhrases["de"][10] = "Ihr verlasst Euren Schlachtzug."

resetPhrases["de"][11] = "hat sich Eurem Schlachtzug angeschlossen."
resetPhrases["de"][12] = "hat Euren Schlachtzug verlassen."

--FR
resetPhrases["fr"][1] = "You have joined a Fellowship."
resetPhrases["fr"][2] = "You have joined a Raid."

resetPhrases["fr"][3] = "has joined your Fellowship."
resetPhrases["fr"][4] = "has joined your Raid."

resetPhrases["fr"][5] = "You dismiss "
resetPhrases["fr"][6] = "You dismiss "

resetPhrases["fr"][7] = " been dismissed from your Fellowship."
resetPhrases["fr"][8] = " been dismissed from your Raid."

resetPhrases["fr"][9]  = "has left your Fellowship."
resetPhrases["fr"][10] = "has left your Raid."

resetPhrases["fr"][11] = "You leave your Fellowship."
resetPhrases["fr"][12] = "You leave your Raid."




---------------------------------------------------------------------
--== collection ===--
---------------------------------------------------------------------

function check_chat_for_collection(chatArgs)

    if collect_chat then

        if not(chat_only_say) or chatArgs.ChatType == Turbine.ChatType.Say then

            for k,chat in ipairs(collection["chat"]) do 
                if chatArgs.Message == chat["Args"].Message then

                    return
                end
            end

            local index = table.getn(collection["chat"])+1

            collection["chat"][index] = {}
            collection["chat"][index]["Args"] = chatArgs


            ChatCollectionChanged(index)
        end

    end

end

---------------------------------------------------------------------
--== Chat ===--
---------------------------------------------------------------------

CHATCOUNT = 1

function Turbine.Chat.Received(sender, args)

    if (args.ChatType == Turbine.ChatType.Emote) or (args.ChatType == Turbine.ChatType.Tell) or (args.ChatType == Turbine.ChatType.FellowLoot) or (args.ChatType == Turbine.ChatType.SelfLoot) or (args.ChatType == Turbine.ChatType.World) or (args.ChatType == Turbine.ChatType.Trade) or (args.ChatType == Turbine.ChatType.LFF) then
        return
    end

    if args.Message ~= nil then

        for i,windata in ipairs(windowdata) do

            if (windata["load"]) then

                for j,data in ipairs(windata["list_chat"]) do
                    local token = string.gsub(data["token"], "-", "")
                    local msg = string.gsub(args.Message, "-", "")

                    if token ~= "" then
                        if string.find(msg, token) then
                            
                            local gt = Turbine.Engine.GetGameTime()
                            local key = token
                            if data["unique"] then
                                key = key..i..j
                            else
                                key = key..i..j..CHATCOUNT
                                CHATCOUNT = CHATCOUNT + 1
                            end

                            if (args.ChatType == Turbine.ChatType.EnemyCombat) then

                                local updateType,initiatorName,targetName,skillName,var1,var2,var3,var4 = ParseCombatChat[locale](string.gsub(string.gsub(args.Message,"<rgb=#......>(.*)</rgb>","%1"),"^%s*(.-)%s*$", "%1"));

                                if updateType == nil then
                                    windows[i]:CheckForAdd(SettingsOverwrite(data, windows[i], key, gt, 1, nil, token, true))
                                else
                                    windows[i]:CheckForAdd(SettingsOverwrite(data, windows[i], key, gt, 1, nil, initiatorName, true))
                                end

                            elseif (args.ChatType == Turbine.ChatType.PlayerCombat) then

                                local updateType,initiatorName,targetName,skillName,var1,var2,var3,var4 =  ParseCombatChat[locale](string.gsub(string.gsub(args.Message,"<rgb=#......>(.*)</rgb>","%1"),"^%s*(.-)%s*$", "%1"));

                                if updateType == nil then
                                    windows[i]:CheckForAdd(SettingsOverwrite(data, windows[i], key, gt, 1, nil, token, true))
                                else
                                    windows[i]:CheckForAdd(SettingsOverwrite(data, windows[i], key, gt, 1, nil, targetName, true))
                                end

                            else
                                    --data, parent, key, start_time, duration, icon, text, running
                                windows[i]:CheckForAdd(SettingsOverwrite(data, windows[i], key, gt, 1, nil, token, true))
                            end


                        end

                    end

                end

            end

        end

        check_chat_for_collection(args)

        if (args.ChatType == Turbine.ChatType.Standard) then

            if windowdata["reload_after_groupchanges"] then

                for i, x in ipairs(resetPhrases[locale]) do

                    if string.find(args.Message, x) then

                        Turbine.Shell.WriteLine("out")
                        ReloadPlugin("Gibberish reload reason: \""..x.."\"")

                    end

                end

            end

        end

        if args.ChatType == Turbine.ChatType.Advancement then

            local message_begin = string.find(args.Message, "You have acquired the Class Specialization Bonus Trait:");
            
            if message_begin ~= nil then
                              
               skill_tree_changed()
                
            end
            
        end

    end


end




































-- resetPhrases = {}
-- resetPhrases[1] = "You have joined a Fellowship."
-- resetPhrases[2] = "You have joined a Raid."

-- resetPhrases[3] = "has joined your Fellowship."
-- resetPhrases[4] = "has joined your Raid."

-- resetPhrases[5] = "You dismiss "
-- resetPhrases[6] = "You dismiss "

-- resetPhrases[7] = " been dismissed from your Fellowship."
-- resetPhrases[8] = " been dismissed from your Raid."

-- resetPhrases[9] = "has left your Fellowship."
-- resetPhrases[10] = "has left your Raid."

-- resetPhrases[11] = "You leave your Fellowship."
-- resetPhrases[12] = "You leave your Raid."


-- ---------------------------------------------------------------------
-- --== collection ===--
-- ---------------------------------------------------------------------

-- function check_chat_for_collection(chatArgs)

--     if collect_chat then

--         if not(chat_only_say) or chatArgs.ChatType == Turbine.ChatType.Say then

--             for k,chat in ipairs(collection["chat"]) do 
--                 if chatArgs.Message == chat["Args"].Message then
--                     chat["Timestamps"][table.getn(chat["Timestamps"]) + 1] = Turbine.Engine.GetGameTime()
--                     return
--                 end
--             end

--             local index = table.getn(collection["chat"])+1

--             collection["chat"][index] = {}
--             collection["chat"][index]["Args"] = chatArgs
--             collection["chat"][index]["Timestamps"] = {}
--             collection["chat"][index]["Timestamps"][1] = Turbine.Engine.GetGameTime()

--             ChatCollectionChanged(index)
--         end

--     end

-- end

-- ---------------------------------------------------------------------
-- --== Chat ===--
-- ---------------------------------------------------------------------
-- -- key: token + sortindex       > unique
-- --      token + sortindex + gt  > nicht unique

-- CHATCOUNT = 1

-- function Turbine.Chat.Received(sender, args)

--     if (args.ChatType == Turbine.ChatType.Tell) or(args.ChatType == Turbine.ChatType.FellowLoot) or (args.ChatType == Turbine.ChatType.SelfLoot) or (args.ChatType == Turbine.ChatType.World) or (args.ChatType == Turbine.ChatType.Trade) or (args.ChatType == Turbine.ChatType.LFF) then
--         return
--     end

--     if args.Message ~= nil then

--         for i,windata in ipairs(windowdata) do

--             if (windata["load"]) then

--                 for j,data in ipairs(windata["list_chat"]) do
--                     local token = string.gsub(data["token"], "-", "")

--                     if token ~= "" then
--                         if string.find( string.gsub(args.Message, "-", ""), token) then
                            
--                             local gt = Turbine.Engine.GetGameTime()
--                             local key = token
--                             if data["unique"] then
--                                 key = key..i..j
--                             else
--                                 key = key..i..j..CHATCOUNT
--                                 CHATCOUNT = CHATCOUNT + 1
--                             end


--                             if (args.ChatType == Turbine.ChatType.EnemyCombat) then

--                                 local updateType,initiatorName,targetName,skillName,var1,var2,var3,var4 = ParseCombatChat(string.gsub(string.gsub(args.Message,"<rgb=#......>(.*)</rgb>","%1"),"^%s*(.-)%s*$", "%1"));

--                                 if data["unique"] then
--                                     key = key
--                                 else
--                                     key = targetName..key
--                                 end
                                

--                                 if updateType == nil then
--                                     windows[i]:CheckForAdd(SettingsOverwrite(data, windows[i], key, gt, 1, nil, token, true))
--                                 else
--                                     windows[i]:CheckForAdd(SettingsOverwrite(data, windows[i], key, gt, 1, nil, initiatorName, true))
--                                 end

--                             elseif (args.ChatType == Turbine.ChatType.PlayerCombat) then

--                                 local updateType,initiatorName,targetName,skillName,var1,var2,var3,var4 = ParseCombatChat(string.gsub(string.gsub(args.Message,"<rgb=#......>(.*)</rgb>","%1"),"^%s*(.-)%s*$", "%1"));

--                                 if data["unique"] then
--                                     key = key
--                                 else
--                                     key = targetName..key
--                                 end

--                                 if updateType == nil then
--                                     windows[i]:CheckForAdd(SettingsOverwrite(data, windows[i], key, gt, 1, nil, token, true))
--                                 else
--                                     windows[i]:CheckForAdd(SettingsOverwrite(data, windows[i], key, gt, 1, nil, targetName, true))
--                                 end

--                             else
--                                     --data, parent, key, start_time, duration, icon, text, running
--                                 windows[i]:CheckForAdd(SettingsOverwrite(data, windows[i], key, gt, 1, nil, token, true))
--                             end


--                         end

--                     end

--                 end

--             end

--         end

--         check_chat_for_collection(args)

--         if (args.ChatType == Turbine.ChatType.Standard) then

--             for i, x in ipairs(resetPhrases) do

--                 if string.find(args.Message, x) then

--                     if settings_window == nil then

--                         ReloadPlugin("Gibberish reload reason: \""..x.."\"")
                        
--                     end

--                 end

--             end

--         end

--         if args.ChatType == Turbine.ChatType.Advancement then

--             local message_begin = string.find(args.Message, "You have acquired the Class Specialization Bonus Trait:");
            
--             if message_begin ~= nil then
                              
--                skill_tree_changed()
                
--             end
            
--         end

--     end


-- end

