function check_effect_group(effect, player_name)

    local effectName = effect:GetName()
    local effectIcon = effect:GetIcon()
    
    for i,windata in ipairs(windowdata) do 

        if (windata["load"]) then

            for j,data in ipairs(windata["list_effects_group"]) do 

                if data["token"] ~= "" then

                    if data["use_regex"] ~= true then

                        if effectName == data["token"] then

                            if data["icon"] ~= nil then

                                if effectIcon == data["icon"] then
                                    local key
                                    if data["unique"] then
                                        key = string.gsub(effectName, "-", "")..i..j..player_name..effectIcon
                                        windows[i]:CheckForAdd(SettingsOverwrite(data, windows[i], key, effect:GetStartTime(), effect:GetDuration(), effectIcon, player_name))  
                                    else
                                        key = string.gsub(effectName, "-", "")..i..j..player_name..effectIcon..effect:GetStartTime()
                                        windows[i]:CheckForAdd(SettingsOverwrite(data, windows[i], key, effect:GetStartTime(), effect:GetDuration(), effectIcon, player_name))                         
                                    end  

                                end

                            else
                                local key
                                if data["unique"] then
                                    key = string.gsub(effectName, "-", "")..i..j..player_name..effectIcon
                                    windows[i]:CheckForAdd(SettingsOverwrite(data, windows[i], key, effect:GetStartTime(), effect:GetDuration(), effectIcon, player_name))  
                                else
                                    key = string.gsub(effectName, "-", "")..i..j..player_name..effectIcon..effect:GetStartTime()   
                                    windows[i]:CheckForAdd(SettingsOverwrite(data, windows[i], key, effect:GetStartTime(), effect:GetDuration(), effectIcon, player_name))                         
                                end  
                            end

                        end

                    else

                        if string.find(effectName, data["token"]) then
                            
                            local text
                            if data["text"] == "%d" then
                                local start_tier, end_tier = string.find(effectName, "%d+")
                                if start_tier ~= nil then
                                    text = string.sub(effectName, start_tier, end_tier).." - "..player_name
                                end
                            else
                                text = player_name
                            end

                            local key
                            if data["unique"] then
                                key = string.gsub(string.gsub(effectName, "-", ""),"%d", "")..i..j..player_name
                            else
                                key = string.gsub(string.gsub(effectName, "-", ""),"%d", "")..i..j..player_name..effect:GetStartTime()
                            end  

                            windows[i]:CheckForAdd(SettingsOverwrite(data, windows[i], key, effect:GetStartTime(), effect:GetDuration(), effectIcon, text))

                        end

                    end

                end

            end

        end

    end

end

function check_activ_Effects_forCollection_Group()

    if group ~= nil then
        local lp_name = lp:GetName()
        for i=1, group:GetMemberCount(), 1 do
            if group:GetMember(i):GetName() ~= lp_name then
                local effects = group:GetMember(i):GetEffects()
                for j=1, effects:GetCount(), 1 do
                    local effect = effects:Get(j)
                    if not(effects_only_debuffs) or effect:IsDebuff() then
                        check_effect_for_collection(effect)
                    end
                end
            end
        end
    end

end

function AddGroupEffectEvents()
    group = lp:GetParty()
    if group ~= nil then

        for i=1, group:GetMemberCount(), 1 do
            local player = group:GetMember(i)
            if  not(player:IsLocalPlayer()) then
                player:GetEffects().EffectAdded = function(sender, args)

                    local effect = player:GetEffects():Get(args.Index)
                    check_effect_group(effect, player:GetName())
                    
                    if collect_effects then
                        if not(effects_only_debuffs) or effect:IsDebuff() then
                            check_effect_for_collection(effect)
                        end            
                    end

                end

                local effects = player:GetEffects()
                
                for j=1, effects:GetCount(), 1 do
                
                    check_effect_group(player:GetEffects():Get(j), player:GetName())
                    
                    if collect_effects then
                        if not(effects_only_debuffs) or effect:IsDebuff() then
                            check_effect_for_collection(effect)
                        end            
                    end

                end
            end
        end

    end

end
