
function check_remove_effect_self(effect)--effectName, effectIcon)

    effectName = effect:GetName()
    effectIcon = effect:GetIcon()

    for i,windata in ipairs(windowdata) do 

        if (windata["load"]) then
--[[ ALL DEBUFFS
            if windata["all_self_debuffs"] and  effect:IsDebuff() then

                local key = string.gsub(effectName, "-", "")..i..effectIcon
                windows[i]:CheckForRemove(key)

            end
]]
            for j,data in ipairs(windata["list_effects_self"]) do 

                if data["use_regex"] ~= true then

                    if effectName == data["token"] then
                        if data["icon"] == nil then

                            local key = string.gsub(effectName, "-", "")..i..j..effectIcon
                            windows[i]:CheckForRemove(key)

                        else

                            if data["icon"] == effectIcon then
                            
                            local key = string.gsub(effectName, "-", "")..i..j..effectIcon
                            windows[i]:CheckForRemove(key)
                            
                            end

                        end

                    end

                else


                    if string.find(effectName, data["token"]) then

                        local key = string.gsub(string.gsub(effectName, "-", ""),"%d", "")..i..j
                        windows[i]:CheckForRemove(key)

                    end


                end

            end

        end

    end

end

function check_effect_self(effect)

    local effectName = effect:GetName()
    local effectIcon = effect:GetIcon()

    for i,windata in ipairs(windowdata) do 

        if (windata["load"]) then

--[[ ALL DEBUFFS
            if windata["all_self_debuffs"] and effect:IsDebuff()  then

                local found = false

                for j,data in ipairs(windata["all_self_debuffs_blacklist"]) do 

                    if data["token"] ~= "" then

                        if effectName == data["token"] then

                            if data["icon"] ~= nil then

                                if effectIcon == data["icon"] then
                                    found = true
                                    break

                                end

                            else
                                found = true
                                break

                            end

                        end

                    end

                end

                local key 

                key = string.gsub(effectName, "-", "")..i..effectIcon..effect:GetID()

                windows[i]:CheckForAdd(SettingsOverwrite(windata["all_self_debuffs_data"], windows[i], key, effect:GetStartTime(), effect:GetDuration(), effectIcon, effectName))

            end
            ]]
            for j,data in ipairs(windata["list_effects_self"]) do 

                if data["token"] ~= "" then

                    if data["use_regex"] ~= true then
                    
                        if effectName == data["token"] then

                            if data["icon"] ~= nil then

                                if effectIcon == data["icon"] then

                                    local key 
                                    if data["unique"] then
                                        key = string.gsub(effectName, "-", "")..i..j..effectIcon
                                    else
                                        key = string.gsub(effectName, "-", "")..i..j..effectIcon..effect:GetID()
                                    end
                                    windows[i]:CheckForAdd(SettingsOverwrite(data, windows[i], key, effect:GetStartTime(), effect:GetDuration(), effectIcon, effectName))
                                end

                            else

                                local key 
                                if data["unique"] then
                                    key = string.gsub(effectName, "-", "")..i..j..effectIcon
                                else
                                    key = string.gsub(effectName, "-", "")..i..j..effectIcon..effect:GetID()
                                end

                                windows[i]:CheckForAdd(SettingsOverwrite(data, windows[i], key, effect:GetStartTime(), effect:GetDuration(), effectIcon, effectName))

                            end
                        
                        end

                    else

                        if string.find(effectName, data["token"]) then

                            local key 
                            if data["unique"] then
                                key = string.gsub(string.gsub(effectName, "-", ""),"%d", "")..i..j
                            else
                                key = string.gsub(string.gsub(effectName, "-", ""),"%d", "")..i..j..effect:GetID()
                            end

                            local text
                            if data["text"] == "%d" then
                                local start_tier, end_tier = string.find(effectName, "%d+")
                                if start_tier ~= nil then
                                    text = string.sub(effectName, start_tier, end_tier)
                                end
                            else
                                text = effectName
                            end
                            
                            windows[i]:CheckForAdd(SettingsOverwrite(data, windows[i], key, effect:GetStartTime(), effect:GetDuration(), effectIcon, text))

                        end

                    end

                end


            end

        end

    end

end

function check_activ_Effects_forCollection_Self()

    local effects = lp:GetEffects()
    for j=1, lp:GetEffects():GetCount(), 1 do

        local effect = lp:GetEffects():Get(j)
        if not(effects_only_debuffs) or effect:IsDebuff() then
            check_effect_for_collection(effect)
        end

    end


end

function CheckAllActivEffects()

    for j=1, lp:GetEffects():GetCount(), 1 do

        local effect = lp:GetEffects():Get(j)
        check_effect_self(effect)
        Trigger.check_effect_group(effect, lp:GetName())
        if collect_effects then
            if not(effects_only_debuffs) or effect:IsDebuff() then
                check_effect_for_collection(effect)
            end            
        end

    end

end

function AddSelfEffectEvents()

    
    lp:GetEffects().EffectRemoved = function(sender, args)

        local effects = lp:GetEffects()
        local effectName = args.Effect:GetName()
        for i=1, effects:GetCount(), 1 do
            if effects:Get(i):GetName() == effectName then
                if effects:Get(i):GetIcon() == args.Effect:GetIcon() then
                    return
                end
            end
        end

        check_remove_effect_self(args.Effect)--args.Effect:GetName(), args.Effect:GetIcon())
    end

    lp:GetEffects().EffectAdded = function(sender, args)
        local effect = lp:GetEffects():Get(args.Index)

        check_effect_self(effect)
        Trigger.check_effect_group(effect, lp:GetName())
        if collect_effects then
            if not(effects_only_debuffs) or effect:IsDebuff() then
                check_effect_for_collection(effect)
            end            
        end

    end

    CheckAllActivEffects()    


end
