function checkeffect_target(effect, target_name)

    local effectName = effect:GetName()
    local effectIcon = effect:GetIcon()


    for i,windata in ipairs(windowdata) do 

        if (windata["load"]) then

            for j,data in ipairs(windata["list_effects_target"]) do 

                if(string.find(target_name, data["target_name"])) then

                    if effectName == data["token"] then

                        if data["icon"] ~= nil then

                            if effectIcon == data["icon"] then
                                local key
                                if data["unique"] then
                                    key = string.gsub(effectName, "-", "")..i..j..target_name..effectIcon
                                else
                                    key = string.gsub(effectName, "-", "")..i..j..target_name..effectIcon..effect:GetStartTime()
                                end
                                windows[i]:CheckForAdd(SettingsOverwrite(data, windows[i], key, effect:GetStartTime(), effect:GetDuration(), effectIcon, target_name))

                            end

                        else
                            local key
                                if data["unique"] then
                                    key = string.gsub(effectName, "-", "")..target_name..effectIcon..i..j
                                else
                                    key = string.gsub(effectName, "-", "")..target_name..effectIcon..i..j..effect:GetStartTime()
                                end
                                windows[i]:CheckForAdd(SettingsOverwrite(data, windows[i], key, effect:GetStartTime(), effect:GetDuration(), effectIcon, target_name))

                        end

                    end

                end
                
            end

        end

    end

    if collect_target_effects then
        if not(effects_target_only_buffs) or not(effect:IsDebuff()) then
            check_effect_for_collection(effect)
        end
    end

end

function AddTargetEffectEvents()

    if lp:GetTarget() ~= nil then

        if not(lp:GetTarget():IsLocalPlayer()) then

            local target = lp:GetTarget()

            if target.GetEffects ~= nil then

                local effects = target:GetEffects()

                effects.EffectAdded = function(sender, args)
                    checkeffect_target(effects:Get(args.Index), target:GetName())
                end

                for i=1, effects:GetCount(), 1 do
                    checkeffect_target(effects:Get(i), target:GetName())
                end

            end

        end

    end

end

function AddEventTargetEffects()

    lp.TargetChanged = function(sender, args)
        AddTargetEffectEvents()
    end

    if lp:GetTarget() ~= nil then
        AddTargetEffectEvents()
    end

end

function check_activ_Effects_forCollection_Target()

    if lp:GetTarget() ~= nil then
        local effects = lp:GetTarget():GetEffects()
        for j=1, lp:GetEffects():GetCount(), 1 do

            local effect = lp:GetEffects():Get(j)
            if not(effects_target_only_buffs) or not(effect:IsDebuff()) then
                check_effect_for_collection(effect)
            end

        end
    end

end