BaseListBox = class( Turbine.UI.Window )

function BaseListBox:Constructor(width, height, left, top, frame_color, back_color, name, parent, newbutton)
    Turbine.UI.Window.Constructor( self )

    self.searchText = ""
    self.parent = parent

    self:SetParent(parent)
    self:SetPosition(left, top)
    self:SetSize(width + 10, height + 10)
    self:SetMouseVisible(true)

    self.frame = Turbine.UI.Window()
    self.frame:SetParent(self)
    self.frame:SetSize(self:GetSize())
    self.frame:SetBackColor(frame_color)
    self.frame:SetOpacity(0.7)
    self.frame:SetMouseVisible(false)
    self.frame:SetZOrder(2)

    self.background = Turbine.UI.Control()
    self.background:SetParent(self.frame)
    self.background:SetPosition(5, 25)
    self.background:SetSize(width, height - 20)
    self.background:SetBackColor(back_color)

    self.foreground = Turbine.UI.Window()
    self.foreground:SetParent(self)
    self.foreground:SetPosition(5, 0)
    self.foreground:SetSize(width, height + 5)
    self.foreground:SetZOrder(4)

    self.label = Turbine.UI.Label()
    self.label:SetParent(self.foreground)
    self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.label:SetMouseVisible(false)
    self.label:SetSize(width , 25)
    --self.label:SetLeft(40)
	self.label:SetFont(Turbine.UI.Lotro.Font.Verdana16)
    self.label:SetText(name)
    self.label:SetForeColor(back_color)

    if newbutton then
        self.new_button = Turbine.UI.Lotro.Button()
        self.new_button:SetParent(self.foreground)
        self.new_button:SetSize(40,20)
        self.new_button:SetLeft(0)
        self.new_button:SetText("New")
        self.new_button:SetVisible(true)
        self.new_button:SetTop(3)
        self.new_button.Click = function()
            self.parent:NewButtonPressed(self)
        end
    end

    self.search = Turbine.UI.Lotro.TextBox()
	self.search:SetSize(self.foreground:GetWidth()-2, 25)
	self.search:SetPosition(1,26)
	self.search:SetParent(self.foreground)
	self.search:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.search:SetFont(Turbine.UI.Lotro.Font.Verdana12)
    self.search:SetFontStyle(Turbine.UI.FontStyle.None)
	self.search:SetForeColor(frame_color)
    self.search:SetText("Search ...")
    self.search.FocusGained = function(sender, args)
		--self.search:SetForeColor(Turbine.UI.Color.White)
		if self.searchText == "" then
			self.search:SetText("")
		end		
	end
	self.search.FocusLost = function(sender, args)
		--self.search:SetForeColor(Turbine.UI.Color(0.7,0.7,0.7))
		if self.searchText == "" then
			self.search:SetText("Search ...")
		end
	end
	self.search.TextChanged = function(sender, args)		
		self.searchText = string.lower(self.search:GetText())
		self.parent:FilterContent(self.searchText, self)
	end

    self.list = Turbine.UI.ListBox()
    self.list:SetParent(self.foreground)
    self.list:SetPosition(1,52)
    self.list:SetSize(self.foreground:GetWidth()-2, self.foreground:GetHeight()-53)
    self.list:SetVisible(true)
    self.list:SetMouseVisible(true)

    self.scroll = Turbine.UI.Lotro.ScrollBar()
    self.scroll:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.scroll:SetParent(self.list)
    self.scroll:SetPosition(self.list:GetWidth()-12,0)
    self.scroll:SetWidth(12)
    self.scroll:SetHeight(self.list:GetHeight())
    self.scroll:SetZOrder(100)
    self.list:SetVerticalScrollBar(self.scroll)

end


---------------------------------------------------------------------
--== public ===--
---------------------------------------------------------------------

function BaseListBox:Sort(func)
    self.list:Sort(func)
end

function BaseListBox:AddItem(item)
    self.list:AddItem(item)
end

function BaseListBox:RemoveItem(item)
    self.list:RemoveItem(item)
end

function BaseListBox:ClearItems()
    self.list:ClearItems()
end

function BaseListBox:Resize(width, height)

    self:SetSize(width + 10, height + 10)
    self.frame:SetSize(self:GetSize())
    self.background:SetSize(width, height - 20)
    self.label:SetSize(width , 25)
    self.foreground:SetSize(width, height + 5)
    self.list:SetSize(self.foreground:GetWidth()-2, self.foreground:GetHeight()-53)
    self.scroll:SetHeight(self.list:GetHeight())

end

---------------------------------------------------------------------
--== private ===--
---------------------------------------------------------------------

function BaseListBox:EnabledChanged()
    self.new_button:SetEnabled(self:IsEnabled())
end

function BaseListBox:ChangeVisiblility(bool)

    self:SetVisible(bool)
    self.frame:SetVisible(self:IsVisible())
    self.foreground:SetVisible(self:IsVisible())
    
end

