BaseWindow = class( Turbine.UI.Window )

function BaseWindow:Constructor(width, height, left, top, frame_color, back_color, name, parent, min_width, min_height, max_width, max_height)
    Turbine.UI.Window.Constructor( self )

    self.parent = parent

    self.min_width = min_width
    self.min_height =min_height

    self.max_width = max_width
    self.max_height =max_height

    self:SetParent(parent)
    self:SetPosition(left, top)
    self:SetSize(width + 10, height + 30)
    self:SetMouseVisible(true)

    self.frame = Turbine.UI.Window()
    self.frame:SetParent(self)
    self.frame:SetSize(self:GetSize())
    self.frame:SetBackColor(frame_color)
    self.frame:SetOpacity(0.7)
    self.frame:SetMouseVisible(false)
    self.frame:SetZOrder(2)

    self.background = Turbine.UI.Control()
    self.background:SetParent(self.frame)
    self.background:SetPosition(5, 25)
    self.background:SetSize(width, height)
    self.background:SetBackColor(back_color)
    self.background:SetOpacity(0.5)

    self.top_bar = Turbine.UI.Window()
    self.top_bar:SetParent(self)
    self.top_bar:SetSize(self:GetWidth(), 25)
    self.top_bar:SetZOrder(4)

    self.label = Turbine.UI.Label()
    self.label:SetParent(self.top_bar)
    self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.label:SetMouseVisible(false)
	self.label:SetSize(width, 25)
	self.label:SetFont(Turbine.UI.Lotro.Font.Verdana16)
    self.label:SetText(name)
    self.label:SetForeColor(back_color)

    self.exit_button = Turbine.UI.Lotro.Button()
    self.exit_button:SetParent(self.top_bar)
    self.exit_button:SetSize(20,20)
    self.exit_button:SetPosition(width-35,3)
    self.exit_button:SetText("X")
    self.exit_button:SetVisible(true)

    self.resize_bottom = Turbine.UI.Control()
    self.resize_bottom:SetSize(self:GetWidth(),5)
    self.resize_bottom:SetPosition(0, self:GetHeight()-5)
    self.resize_bottom:SetParent(self)
    self.resize_bottom:SetZOrder(7)

    self.resize_right = Turbine.UI.Control()
    self.resize_right:SetSize(5,self:GetHeight())
    self.resize_right:SetPosition(self:GetWidth()-5, 0)
    self.resize_right:SetParent(self)
    self.resize_right:SetZOrder(8)

    self.resize_corner = Turbine.UI.Control()
    self.resize_corner:SetSize(10,10)
    self.resize_corner:SetPosition(self:GetWidth()-10, self:GetHeight()-10)
    self.resize_corner:SetParent(self)
    self.resize_corner:SetZOrder(9)

--Right
self.resize_right.MouseDown = function( sender, args )
    if args.Button == Turbine.UI.MouseButton.Left then
        self.draggingSize = true	

        self.dragSizeStartX = args.X
        self.dragSizeStartY = args.Y

    end
end

self.resize_right.MouseMove = function( sender, args )
    if self.draggingSize then
        local x,y = self:GetSize()
        x = x  + ( args.X - self.dragSizeStartX )
        --y = y  + ( args.Y - self.dragSizeStartY )

        self:Resize(x, y)
        
    end
end

self.resize_right.MouseUp = function( sender, args )
    if args.Button == Turbine.UI.MouseButton.Left then
        self.draggingSize = false
        if self.parent.data ~= nil then
            self.parent.data["width"] = self:GetWidth()-10
            self.parent.data["height"] = self:GetHeight()
            
            SaveSettings()
        end

    end
    
end

--Bottom
self.resize_bottom.MouseDown = function( sender, args )
    if args.Button == Turbine.UI.MouseButton.Left then
        self.draggingSize = true	

        self.dragSizeStartX = args.X
        self.dragSizeStartY = args.Y

    end
end

self.resize_bottom.MouseMove = function( sender, args )
    if self.draggingSize then
        local x,y = self:GetSize()
        --x = x  + ( args.X - self.dragSizeStartX )
        y = y  + ( args.Y - self.dragSizeStartY )

        self:Resize(x, y)
        
    end
end

self.resize_bottom.MouseUp = function( sender, args )
    if args.Button == Turbine.UI.MouseButton.Left then
        self.draggingSize = false
        if self.parent.data ~= nil then
            self.parent.data["width"] = self:GetWidth()-10
            self.parent.data["height"] = self:GetHeight()

            SaveSettings()
        end
    end
    
end

--Corner
    self.resize_corner.MouseDown = function( sender, args )
		if args.Button == Turbine.UI.MouseButton.Left then
            self.draggingSize = true	

			self.dragSizeStartX = args.X
            self.dragSizeStartY = args.Y

		end
	end
	
	self.resize_corner.MouseMove = function( sender, args )
		if self.draggingSize then
			local x,y = self:GetSize()
			x = x  + ( args.X - self.dragSizeStartX )
            y = y  + ( args.Y - self.dragSizeStartY )

            self:Resize(x, y)
            
		end
	end
	
	self.resize_corner.MouseUp = function( sender, args )
		if args.Button == Turbine.UI.MouseButton.Left then
            self.draggingSize = false
            if self.parent.data ~= nil then
                self.parent.data["width"] = self:GetWidth()-10
                self.parent.data["height"] = self:GetHeight()

                SaveSettings()
            end
        end
        
    end

    self.exit_button.Click = function(sender, args)
        self:Close()
    end

    self.top_bar.MouseDown = function( sender, args )
		if args.Button == Turbine.UI.MouseButton.Left then
			self.dragging = true	
			self.dragStartX = args.X
			self.dragStartY = args.Y
		end
	end
	
	self.top_bar.MouseMove = function( sender, args )
		if self.dragging then
			local x,y = self.parent:GetPosition()	
			x = x + ( args.X - self.dragStartX )
			y = y + ( args.Y - self.dragStartY )	
            self.parent:SetPosition( x, y )
            
		end
	end
	
	self.top_bar.MouseUp = function( sender, args )
		if args.Button == Turbine.UI.MouseButton.Left then
            self.dragging = false
            if self.parent.data ~= nil then
                self.parent.data["left"],self.parent.data["top"] = self.parent:GetPosition()
                    
                SaveSettings()
            end
		end
    end

end


---------------------------------------------------------------------
--== public ===--
---------------------------------------------------------------------

function BaseWindow:SetText(text)
    self.label:SetText(text)
end

---------------------------------------------------------------------
--== private ===--
---------------------------------------------------------------------

function BaseWindow:Resize(width, height)

    width = width - 10
    height = height - 30

    if self.min_width ~= nil then
        if width < self.min_width then
            width = self.min_width
        end
    end
    if self.min_height ~= nil then
        if height < self.min_height then
            height = self.min_height
        end
    end

    if self.max_width ~= nil then
        if width > self.max_width then
            width = self.max_width
        end
    end
    if self.max_height ~= nil then
        if height > self.max_height then
            height = self.max_height
        end
    end

    self.parent:Resize( width, height )

    self:SetSize(width + 10, height + 30)
    self.frame:SetSize(self:GetSize())
    self.background:SetSize(width, height)

    self.top_bar:SetSize(self:GetWidth(), 25)
    self.exit_button:SetPosition(width-35,3)
    self.label:SetSize(width, 25)

    self.resize_bottom:SetPosition(0, self:GetHeight()-5)
    self.resize_right:SetPosition(self:GetWidth()-5, 0)
    self.resize_corner:SetPosition(self:GetWidth()-10, self:GetHeight()-10)


end

function BaseWindow:ChangeVisiblility(bool)

    self:SetVisible(bool)
    self.frame:SetVisible(self:IsVisible())
    self.top_bar:SetVisible(self:IsVisible())

end

function BaseWindow:Closing()

    self.frame:Close()
    self.top_bar:Close()

end

function BaseWindow:Closed()

    self.frame:Close()
    self.top_bar:Close()
    self.parent:Close()
end