LISTBOXWIDTH = 200
LIBRARY = 0
COLLECTION = 1

-- EFFECTS_SELF = 1
-- EFFECTS_GROUP = 2
-- EFFECTS_TARGET = 3
-- CHAT = 4
-- SKILL = 5
-- TRIGGER_END = 6

Window = class( Turbine.UI.Window )

function Window:Constructor()
    Turbine.UI.Window.Constructor( self )

    self.c_effect_controls = {}
    self.c_chat_controls = {}

    self.l_effect_controls = {}
    self.l_chat_controls = {}


    windowdata["collection"]["width"] = 200
    windowdata["collection"]["height"] = 330
    
    self.data = windowdata["collection"]

    self:SetSize(windowdata["collection"]["width"] + LISTBOXWIDTH + 30 + LISTBOXWIDTH + 30, windowdata["collection"]["height"] + 30)
    self:SetPosition(windowdata["collection"]["left"], windowdata["collection"]["top"])
    self:SetMouseVisible(false)

    self.back = UI.Settings.BaseWindow(windowdata["collection"]["width"], windowdata["collection"]["height"],  LISTBOXWIDTH + 25,  0, Turbine.UI.Color.White, Turbine.UI.Color.Black, Utils.L[locale]["header"]["tracking"], self, 200, 330, 200, nil)
    self.back:ChangeVisiblility(true)
    self.back:SetZOrder(2)

    self:SetWantsKeyEvents(true)
    self.KeyDown = function(sender, args)
        if args.Action == 145 then
            self.back:Close()
        end
    end

    self.libraryWindow = UI.Settings.BaseListBox(LISTBOXWIDTH, windowdata["collection"]["height"] -5, 0, 25, Turbine.UI.Color.White, Turbine.UI.Color.Black, Utils.L[locale]["header"]["library"], self, false)
    self.libraryWindow:ChangeVisiblility(true)
    self.libraryWindow:SetZOrder(4)

    self.collectionWindow = UI.Settings.BaseListBox(LISTBOXWIDTH, windowdata["collection"]["height"] -5, windowdata["collection"]["width"] + 20 + LISTBOXWIDTH + 30, 25, Turbine.UI.Color.White, Turbine.UI.Color.Black, Utils.L[locale]["header"]["collection"], self, false)
    self.collectionWindow:ChangeVisiblility(true)
    self.collectionWindow:SetZOrder(4)

    
    self.foreground = Turbine.UI.Window()
    self.foreground:SetParent(self)
    self.foreground:SetPosition(5+ LISTBOXWIDTH + 30 , 25)
    self.foreground:SetSize(windowdata["collection"]["width"] , windowdata["collection"]["height"] )
    self.foreground:SetVisible(true)
    self.foreground:SetZOrder(6) 

    self.effectsheader = Turbine.UI.Label()
    self.effectsheader:SetParent(self.foreground)
    self.effectsheader:SetSize(self.foreground:GetWidth(), 20)
    self.effectsheader:SetTop(30)
    self.effectsheader:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.effectsheader:SetFont(Turbine.UI.Lotro.Font.Verdana18)
    self.effectsheader:SetText(Utils.L[locale]["header"]["effects"])

    self.effect_collect_button = Turbine.UI.Lotro.Button()
    self.effect_collect_button:SetParent(self.foreground)
    self.effect_collect_button:SetSize(80,20)
    self.effect_collect_button:SetPosition(10,60)
    self.effect_collect_button:SetText(Utils.L[locale]["button"]["collect"])
    self.effect_collect_button:SetVisible(true)
    self.effect_collect_button:SetEnabled(not(collect_effects))
    self.effect_collect_button.Click = function(sender, args)
        self.effect_collect_button:SetEnabled(false)
        self.effect_stop_button:SetEnabled(true)
        SetEffects_Collect(true)
        check_activ_Effects()
    end

    self.effect_stop_button = Turbine.UI.Lotro.Button()
    self.effect_stop_button:SetParent(self.foreground)
    self.effect_stop_button:SetSize(80,20)
    self.effect_stop_button:SetPosition(100,60)
    self.effect_stop_button:SetText(Utils.L[locale]["button"]["stop"])
    self.effect_stop_button:SetVisible(true)
    self.effect_stop_button:SetEnabled(collect_effects)
    self.effect_stop_button.Click = function(sender, args)
        self.effect_collect_button:SetEnabled(true)
        self.effect_stop_button:SetEnabled(false)
        SetEffects_Collect(false)
    end

    self.effects_only_debuffs =  Turbine.UI.Lotro.CheckBox()
	self.effects_only_debuffs:SetParent(self.foreground)
	self.effects_only_debuffs:SetSize(120,25)
	self.effects_only_debuffs:SetPosition(15,88)
	self.effects_only_debuffs:SetFont(Turbine.UI.Lotro.Font.Verdana12)
	self.effects_only_debuffs:SetText(Utils.L[locale]["only_debuffs"])
	self.effects_only_debuffs:SetChecked(effects_only_debuffs)
	self.effects_only_debuffs.CheckedChanged = function(sender, args)
		SetEffect_OnlyDebuffs(self.effects_only_debuffs:IsChecked())
    end
    
---------------------------------------------------------------------
--== chat ===--

    self.chatheader = Turbine.UI.Label()
    self.chatheader:SetParent(self.foreground)
    self.chatheader:SetSize(self.foreground:GetWidth(), 20)
    self.chatheader:SetTop(120)
    self.chatheader:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.chatheader:SetFont(Turbine.UI.Lotro.Font.Verdana18)
    self.chatheader:SetText(Utils.L[locale]["header"]["chat"])

    self.chat_collect_button = Turbine.UI.Lotro.Button()
    self.chat_collect_button:SetParent(self.foreground)
    self.chat_collect_button:SetSize(80,20)
    self.chat_collect_button:SetPosition(10,150)
    self.chat_collect_button:SetText(Utils.L[locale]["button"]["collect"])
    self.chat_collect_button:SetVisible(true)
    self.chat_collect_button:SetEnabled(not(collect_chat))
    self.chat_collect_button.Click = function(sender, args)
        self.chat_collect_button:SetEnabled(false)
        self.chat_stop_button:SetEnabled(true)
        SetChat_Collect(true)
    end

    self.chat_stop_button = Turbine.UI.Lotro.Button()
    self.chat_stop_button:SetParent(self.foreground)
    self.chat_stop_button:SetSize(80,20)
    self.chat_stop_button:SetPosition(100,150)
    self.chat_stop_button:SetText(Utils.L[locale]["button"]["stop"])
    self.chat_stop_button:SetVisible(true)
    self.chat_stop_button:SetEnabled(collect_chat)
    self.chat_stop_button.Click = function(sender, args)
        self.chat_collect_button:SetEnabled(true)
        self.chat_stop_button:SetEnabled(false)
        SetChat_Collect(false)
    end

    self.chat_only_say =  Turbine.UI.Lotro.CheckBox()
	self.chat_only_say:SetParent(self.foreground)
	self.chat_only_say:SetSize(120,25)
	self.chat_only_say:SetPosition(15,178)
	self.chat_only_say:SetFont(Turbine.UI.Lotro.Font.Verdana12)
	self.chat_only_say:SetText(Utils.L[locale]["only_say"])
	self.chat_only_say:SetChecked(chat_only_say)
	self.chat_only_say.CheckedChanged = function(sender, args)
		SetChat_OnlySay(self.chat_only_say:IsChecked())
    end
    
---------------------------------------------------------------------
--== target ===--

    self.targetheader = Turbine.UI.Label()
    self.targetheader:SetParent(self.foreground)
    self.targetheader:SetSize(self.foreground:GetWidth(), 20)
    self.targetheader:SetTop(210)
    self.targetheader:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.targetheader:SetFont(Turbine.UI.Lotro.Font.Verdana18)
    self.targetheader:SetText(Utils.L[locale]["header"]["target_effects"])

    self.target_effect_collect_button = Turbine.UI.Lotro.Button()
    self.target_effect_collect_button:SetParent(self.foreground)
    self.target_effect_collect_button:SetSize(80,20)
    self.target_effect_collect_button:SetPosition(10,240)
    self.target_effect_collect_button:SetText(Utils.L[locale]["button"]["collect"])
    self.target_effect_collect_button:SetVisible(true)
    self.target_effect_collect_button:SetEnabled(not(collect_target_effects))
    self.target_effect_collect_button.Click = function(sender, args)
        self.target_effect_collect_button:SetEnabled(false)
        self.target_effect_stop_button:SetEnabled(true)

        SetTarget_CollectEffects(true)
        check_activ_Effects()
    end

    self.target_effect_stop_button = Turbine.UI.Lotro.Button()
    self.target_effect_stop_button:SetParent(self.foreground)
    self.target_effect_stop_button:SetSize(80,20)
    self.target_effect_stop_button:SetPosition(100,240)
    self.target_effect_stop_button:SetText(Utils.L[locale]["button"]["stop"])
    self.target_effect_stop_button:SetVisible(true)
    self.target_effect_stop_button:SetEnabled(collect_target_effects)
    self.target_effect_stop_button.Click = function(sender, args)
        self.target_effect_collect_button:SetEnabled(true)
        self.target_effect_stop_button:SetEnabled(false)

        SetTarget_CollectEffects(false)
    end

    self.target_effects_only_buffs =  Turbine.UI.Lotro.CheckBox()
    self.target_effects_only_buffs:SetParent(self.foreground)
    self.target_effects_only_buffs:SetSize(120,25)
    self.target_effects_only_buffs:SetPosition(15,268)
    self.target_effects_only_buffs:SetFont(Turbine.UI.Lotro.Font.Verdana12)
    self.target_effects_only_buffs:SetText(Utils.L[locale]["only_buffs"])
    self.target_effects_only_buffs:SetChecked(effects_target_only_buffs)
    self.target_effects_only_buffs.CheckedChanged = function(sender, args)
        SetTarget_OnlyBuffs(self.target_effects_only_buffs:IsChecked())
    end

    self:TrackTargetChanged()

---------------------------------------------------------------------
--== headers ===--
    self.collectionWindow_effectsheader = Turbine.UI.Label()
    self.collectionWindow_effectsheader:SetSize(LISTBOXWIDTH - 2, 20)
    self.collectionWindow_effectsheader:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.collectionWindow_effectsheader:SetFont(Turbine.UI.Lotro.Font.Verdana18)
    self.collectionWindow_effectsheader:SetText(Utils.L[locale]["header"]["effects"])

    self.collectionWindow_chatheader = Turbine.UI.Label()
    self.collectionWindow_chatheader:SetSize(LISTBOXWIDTH - 2, 20)
    self.collectionWindow_chatheader:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.collectionWindow_chatheader:SetFont(Turbine.UI.Lotro.Font.Verdana18)
    self.collectionWindow_chatheader:SetText(Utils.L[locale]["header"]["chat"])

    self.libraryWindow_effectsheader = Turbine.UI.Label()
    self.libraryWindow_effectsheader:SetSize(LISTBOXWIDTH - 2, 20)
    self.libraryWindow_effectsheader:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.libraryWindow_effectsheader:SetFont(Turbine.UI.Lotro.Font.Verdana18)
    self.libraryWindow_effectsheader:SetText(Utils.L[locale]["header"]["effects"])

    self.libraryWindow_chatheader = Turbine.UI.Label()
    self.libraryWindow_chatheader:SetSize(LISTBOXWIDTH - 2, 20)
    self.libraryWindow_chatheader:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.libraryWindow_chatheader:SetFont(Turbine.UI.Lotro.Font.Verdana18)
    self.libraryWindow_chatheader:SetText(Utils.L[locale]["header"]["chat"])

    self:Fill()
    self:SetVisible(true)

end

function Window:Closed()
    collection_Close()
end

---------------------------------------------------------------------
--== public ===--
---------------------------------------------------------------------

function Window:TrackTargetChanged()
    if windowdata["track_effects_target"] == false then
        self.targetheader:SetEnabled(false)
        self.target_effect_collect_button:SetEnabled(false)
        self.target_effect_stop_button:SetEnabled(false)
        self.target_effects_only_buffs:SetEnabled(false)
    else
        self.targetheader:SetEnabled(true)
        self.target_effect_collect_button:SetEnabled(not(collect_target_effects))
        self.target_effect_stop_button:SetEnabled(collect_target_effects)
        self.target_effects_only_buffs:SetEnabled(true)
    end
end

function Window:Resize(width, height)
    
    self:SetSize(width + LISTBOXWIDTH + 30 + LISTBOXWIDTH + 30, height + 30)

    self.collectionWindow:Resize(LISTBOXWIDTH, height -5)

    self.libraryWindow:Resize(LISTBOXWIDTH, height -5)

end

function Window:EffectCollectionChanged(index)

    local i = table.getn(self.c_effect_controls)+1
    self.c_effect_controls[i] = CollectionItem(collection["effects"][index]["name"], collection["effects"][index]["icon"], collection["effects"][index]["description"], collection["effects"][index]["name"], collection["effects"][index]["duration"], nil, self, i, EFFECTS_SELF, COLLECTION)

    self:FillCollection()

end

function Window:ChatCollectionChanged(index)

    local i = table.getn(self.c_chat_controls)+1
    self.c_chat_controls[i] = CollectionItem(collection["chat"][index]["Args"].ChatType, nil, collection["chat"][index]["Args"].Message, collection["chat"][index]["Args"].Message, nil, nil, self, i, CHAT, COLLECTION)

    self:FillCollection()

end

function Window:FilterContent(text, sender)

    if sender == self.collectionWindow then

        self.collectionWindow:ClearItems()

        self.collectionWindow:AddItem(self.collectionWindow_effectsheader)
        for index, control in ipairs(self.c_effect_controls) do
            if string.find(string.lower(control.token), text) then
                self.collectionWindow:AddItem(control)
            end
        end

        self.collectionWindow:AddItem(self.collectionWindow_chatheader)
        for index, control in ipairs(self.c_chat_controls) do
            if string.find(string.lower(control.token), text) then
                self.collectionWindow:AddItem(control)
            end
        end

    elseif sender == self.libraryWindow then

        self.libraryWindow:ClearItems()

        self.libraryWindow:AddItem(self.libraryWindow_effectsheader)
        for index, control in ipairs(self.l_effect_controls) do
            if string.find(string.lower(control.token), text) then
                self.libraryWindow:AddItem(control)
            end
        end

        self.libraryWindow:AddItem(self.libraryWindow_chatheader)
        for index, control in ipairs(self.l_chat_controls) do
            if string.find(string.lower(control.token), text) then
                self.libraryWindow:AddItem(control)
            end
        end

    end

end

---------------------------------------------------------------------
--== private ===--
---------------------------------------------------------------------

function Window:Fill()
    self:FillCollection()
    self:FillLibrary()
end

function Window:FillCollection()

    self.collectionWindow:ClearItems()

    self.collectionWindow:AddItem(self.collectionWindow_effectsheader)
    for i,effect in ipairs(collection["effects"]) do

        self.c_effect_controls[i] = CollectionItem(effect["name"], effect["icon"], effect["description"], effect["name"], effect["duration"], nil, self, i, EFFECTS_SELF, COLLECTION)
        self.collectionWindow:AddItem(self.c_effect_controls[i])

    end

    self.collectionWindow:AddItem(self.collectionWindow_chatheader)
    for i,chat in ipairs(collection["chat"]) do

        self.c_chat_controls[i] = CollectionItem(ChatTypeToString(chat["Args"].ChatType), nil, chat["Args"].Message, chat["Args"].Message, nil, nil, self, i, CHAT, COLLECTION)
        self.collectionWindow:AddItem(self.c_chat_controls[i])

    end

end


function Window:FillLibrary()

    self.libraryWindow:ClearItems()

    --effect
    self.libraryWindow:AddItem(self.libraryWindow_effectsheader)
    for i,effect in ipairs(library["effects"]) do

        self.l_effect_controls[i] = CollectionItem(effect["name"], effect["icon"], effect["description"], effect["name"], effect["duration"], nil, self, i, EFFECTS_SELF, LIBRARY)
        self.libraryWindow:AddItem(self.l_effect_controls[i])

    end

    --chat
    self.libraryWindow:AddItem(self.libraryWindow_chatheader)
    for i,chat in ipairs(library["chat"]) do

        self.l_chat_controls[i] = CollectionItem(ChatTypeToString(chat["Args"].ChatType), nil, chat["Args"].Message, chat["Args"].Message, nil, nil, self, i, CHAT, LIBRARY)
        self.libraryWindow:AddItem(self.l_chat_controls[i])

    end


end

function Window:MoveItem(side, type, index)

    if side == COLLECTION then

        local typeText = nil

        if type == EFFECTS_SELF then
            typeText = "effects"
        elseif type == CHAT then
            typeText = "chat"
        else
            return
        end

        library[typeText][table.getn(library[typeText])+1] = collection[typeText][index]

        collection[typeText][index] = collection[typeText][table.getn(collection[typeText])]
        collection[typeText][table.getn(collection[typeText])] = nil

        self:Fill()
        SaveLibrary()
        
    elseif side == LIBRARY then

        local typeText = nil

        if type == EFFECTS_SELF then
            typeText = "effects"
        elseif type == CHAT then
            typeText = "chat"
        else
            return
        end

        collection[typeText][table.getn(collection[typeText])+1] = library[typeText][index]

        library[typeText][index] = library[typeText][table.getn(library[typeText])]
        library[typeText][table.getn(library[typeText])] = nil

        self:Fill()
        SaveLibrary()

    end

end

---------------------------------------------------------------------
--=====--
---------------------------------------------------------------------
-- Item
---------------------------------------------------------------------
--=====--
---------------------------------------------------------------------

CollectionItem = class( Turbine.UI.Control )

function CollectionItem:Constructor(token, icon, description, searchtoken, duration, cd, parent, index, type, side)
    Turbine.UI.Control.Constructor( self )

    self.token = searchtoken

    self.parent = parent
    self.index = index
    self.type = type
    self.side = side

    local height = 92
    if description == "" then
        height = 42
    end
    self:SetSize(LISTBOXWIDTH-2, height+2)

    self.background = Turbine.UI.Control()
    self.background:SetMouseVisible(false)
    self.background:SetSize(LISTBOXWIDTH-2, height)
    self.background:SetParent(self)
    self.background:SetBackColor(Turbine.UI.Color(0.1,0.1,0.1))
    self.background:SetZOrder(1)

    self.iconControl = Turbine.UI.Control()
    self.iconControl:SetMouseVisible(false)
    self.iconControl:SetParent(self)
    self.iconControl:SetSize(32,32)
    if icon == nil then
        self.iconControl:SetBackColor(Turbine.UI.Color(0.2,0.2,0.2))
    else
        self.iconControl:SetBackground(icon)
    end
    self.iconControl:SetPosition(2,2)
    self.iconControl:SetZOrder(2)

    self.tokenText = Turbine.UI.Label()
    self.tokenText:SetParent(self)
	self.tokenText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.tokenText:SetMouseVisible(false)
    self.tokenText:SetLeft(34)
    self.tokenText:SetSize(self:GetWidth()-36, 42)
	self.tokenText:SetFont(Turbine.UI.Lotro.Font.Verdana14)
    self.tokenText:SetText(token)
    self.tokenText:SetZOrder(3)

    self.descriptionText = Turbine.UI.Label()
    self.descriptionText:SetParent(self)
    self.descriptionText:SetMarkupEnabled(true)
    self.descriptionText:SetMouseVisible(false)
	self.descriptionText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.descriptionText:SetMouseVisible(false)
    self.descriptionText:SetLeft(2)
    self.descriptionText:SetTop(42)
    self.descriptionText:SetSize(self:GetWidth()-4, self:GetHeight()-42)
	self.descriptionText:SetFont(Turbine.UI.Lotro.Font.Verdana12)
    self.descriptionText:SetForeColor(Turbine.UI.Color(0.7,0.7,0.7))
    self.descriptionText:SetText(description)
    self.descriptionText:SetZOrder(3)

    self.MouseEnter = function(sender, args)
        self.background:SetBackColor(Turbine.UI.Color(0.3,0.3,0.3))
	end
	
	self.MouseLeave = function(sender, args)

        self.background:SetBackColor(Turbine.UI.Color(0.1,0.1,0.1))

	end

    self.MouseClick = function()

        self.parent:MoveItem(self.side, self.type, self.index)

    end

end