Tooltip = class( Turbine.UI.Window )

function Tooltip:Constructor()
    Turbine.UI.Window.Constructor( self )

    self:Draw()


end

---------------------------------------------------------------------
--== public ===--
---------------------------------------------------------------------

function Tooltip:SetTooltip(parent, text, width, height, left, top)

    if windowdata["settings"]["show_tooltips"] == false then
        return
    else

        self:SetParent(parent)
        self:SetSize(width,height)
        self.frame:SetSize(width,height)
        self.background:SetSize(width-4,height-4)
        self.text:SetSize(width-10,height-10)
        self:SetPosition(left-(width/2), top)
        self:SetVisible(true)
        self.frame:SetVisible(true)

        self.text:SetText(text)

    end
end

function Tooltip:RemoveTooltip()
    self:SetVisible(false)
    self.frame:SetVisible(true)
    
end

---------------------------------------------------------------------
--== private ===--
---------------------------------------------------------------------

function Tooltip:Draw()

    self:SetMouseVisible(false)
    self:SetZOrder(10)

    self.frame = Turbine.UI.Window()
    self.frame:SetParent(self)
    self.frame:SetBackColor(Turbine.UI.Color.White)
    --self.frame:SetOpacity(0.7)
    self.frame:SetMouseVisible(false)
    

    self.background = Turbine.UI.Control()
    self.background:SetParent(self.frame)
    self.background:SetPosition(2,2)
    self.background:SetBackColor(Turbine.UI.Color.Black)
    self.background:SetMouseVisible(false)
    --self.background:SetOpacity(0.5)
    self.background:SetZOrder(2)

    self.text = Turbine.UI.Label()
    self.text:SetParent(self.frame)
    self.text:SetSize(200, 25)
    self.text:SetPosition(5, 5)
    self.text:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.text:SetFont(Turbine.UI.Lotro.Font.Verdana14)
    self.text:SetForeColor(Turbine.UI.Color.White)
    self.text:SetMouseVisible(false)
    self.text:SetZOrder(5)


end