TRIGGERWINDOW_WIDTH = 310
TRIGGERWINDOW_HEIGHT = 450
TRIGGERWINDOWCOLLECTION_WIDTH = 200
TB_FONT = Turbine.UI.Lotro.Font.Verdana14

TriggerWindow = class( Turbine.UI.Window )

function TriggerWindow:Constructor(data, parent)
    Turbine.UI.Window.Constructor( self )

    self.parent = parent

    self.effect_controls = {}
    self.chat_controls = {}
    self.skill_controls = {}
    self.trigger_controls = {}

    self:SetSize(TRIGGERWINDOW_WIDTH + TRIGGERWINDOWCOLLECTION_WIDTH + 25,  TRIGGERWINDOW_HEIGHT + 25)
    self:SetPosition(300,400)
    self:SetMouseVisible(false)

    self.back = UI.Settings.BaseWindow(TRIGGERWINDOW_WIDTH, TRIGGERWINDOW_HEIGHT,  0,  0, Turbine.UI.Color.White, Turbine.UI.Color.Black, heading, self,TRIGGERWINDOW_WIDTH, TRIGGERWINDOW_HEIGHT, TRIGGERWINDOW_WIDTH, TRIGGERWINDOW_HEIGHT)
    self.back:ChangeVisiblility(true)
    self.back:SetZOrder(2)

    self.collection = UI.Settings.BaseListBox(TRIGGERWINDOWCOLLECTION_WIDTH, TRIGGERWINDOW_HEIGHT - 5, TRIGGERWINDOW_WIDTH + 20, 25, Turbine.UI.Color.White, Turbine.UI.Color.Black, "", self, false)
    self.collection:ChangeVisiblility(true)
    self.collection:SetZOrder(4)

    self.foreground = Turbine.UI.Window()
    self.foreground:SetParent(self)
    self.foreground:SetPosition(5, 25)
    self.foreground:SetSize(TRIGGERWINDOW_WIDTH, TRIGGERWINDOW_HEIGHT)
    self.foreground:SetVisible(true)
    self.foreground:SetZOrder(6)

    self.effectsheader = Turbine.UI.Label()
    self.effectsheader:SetSize(TRIGGERWINDOWCOLLECTION_WIDTH - 2, 20)
    self.effectsheader:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.effectsheader:SetFont(Turbine.UI.Lotro.Font.Verdana18)
    self.effectsheader:SetText(Utils.L[locale]["header"]["effects"])


    self.chatheader = Turbine.UI.Label()
    self.chatheader:SetSize(TRIGGERWINDOWCOLLECTION_WIDTH - 2, 20)
    self.chatheader:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.chatheader:SetFont(Turbine.UI.Lotro.Font.Verdana18)
    self.chatheader:SetText(Utils.L[locale]["header"]["chat"])

    self.skillheader = Turbine.UI.Label()
    self.skillheader:SetSize(TRIGGERWINDOWCOLLECTION_WIDTH - 2, 20)
    self.skillheader:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.skillheader:SetFont(Turbine.UI.Lotro.Font.Verdana18)
    self.skillheader:SetText(Utils.L[locale]["header"]["skill"])

    self.triggerheader = Turbine.UI.Label()
    self.triggerheader:SetSize(TRIGGERWINDOWCOLLECTION_WIDTH - 2, 20)
    self.triggerheader:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.triggerheader:SetFont(Turbine.UI.Lotro.Font.Verdana18)
    self.triggerheader:SetText(Utils.L[locale]["header"]["triggers"])

    self:Draw()
    self:SetData(data)
    self:SetVisible(true)

end

---------------------------------------------------------------------
--== public ===--
---------------------------------------------------------------------

function TriggerWindow:ControlClicked(token, iconID, duration)

    if token ~= nil then
        self.token:SetText(token)
    end
    
    if iconID ~= nil then
        self.icon:SetBackColor()
        self.icon:SetBackground(iconID)
        self.icon_tb:SetText(iconID)
    end

    if duration ~= nil then
        self.timer:SetText(duration)
    end

end

function TriggerWindow:SetData(data)

    self.data = data

    local heading
    if data["type"] == 1 then
        heading = "Effect Self"
        self:FillEffectCollection()
    elseif data["type"] == 2 then
        heading = "Effect Group"
        self:FillEffectCollection()
    elseif data["type"] == 3 then
        heading = "Effect Target"
        self:FillEffectCollection()
    elseif data["type"] == 4 then
        heading = "Chat"
        self:FillChatCollection()
    elseif data["type"] == 5 then
        heading = "Skill"
        self:FillSkillCollection()
    elseif data["type"] == 6 then
        heading = "Trigger End"
        self:FillTriggerCollection()
    elseif data["type"] == 7 then
        heading = "Trigger Threshold"
        self:FillTriggerCollection()
    elseif data["type"] == 8 then
        heading = "Trigger Start"
        self:FillTriggerCollection()
    end
    self.back:SetText(heading)

    self:FillInformation()

end

function TriggerWindow:EffectCollectionChanged(index)

    if self.data["type"] == 1 then
        self:FillEffectCollection()
    elseif self.data["type"] == 2 then
        self:FillEffectCollection()
    elseif self.data["type"] == 3 then
        self:FillEffectCollection()
    elseif self.data["type"] == 4 then
        self:FillChatCollection()
    elseif self.data["type"] == 5 then
        self:FillSkillCollection()
    elseif self.data["type"] == 6 then
        self:FillTriggerCollection()
    elseif self.data["type"] == 7 then
        self:FillTriggerCollection()
    elseif self.data["type"] == 8 then
        self:FillTriggerCollection()
    end

    self:FilterContent(self.collection.searchText)
end

function TriggerWindow:ChatCollectionChanged(index)

    if self.data["type"] == 1 then
        self:FillEffectCollection()
    elseif self.data["type"] == 2 then
        self:FillEffectCollection()
    elseif self.data["type"] == 3 then
        self:FillEffectCollection()
    elseif self.data["type"] == 4 then
        self:FillChatCollection()
    elseif self.data["type"] == 5 then
        self:FillSkillCollection()
    elseif self.data["type"] == 6 then
        self:FillTriggerCollection()
    elseif self.data["type"] == 7 then
        self:FillTriggerCollection()
    elseif self.data["type"] == 8 then
        self:FillTriggerCollection()
    end

    self:FilterContent(self.collection.searchText)
end

function TriggerWindow:FilterContent(text)

    self.collection:ClearItems()

    self.collection:AddItem(self.effectsheader)
    for index, control in ipairs(self.effect_controls) do
        if string.find(string.lower(control.text), text) then
            self.collection:AddItem(control)
        end
    end

    self.collection:AddItem(self.chatheader)
    for index, control in ipairs(self.chat_controls) do
        if string.find(string.lower(control.text), text) then
            self.collection:AddItem(control)
        end
    end

    self.collection:AddItem(self.skillheader)
    for index, control in ipairs(self.skill_controls) do
        if string.find(string.lower(control.text), text) then
            self.collection:AddItem(control)
        end
    end

    self.collection:AddItem(self.triggerheader)
    for index, control in ipairs(self.trigger_controls) do
        if string.find(string.lower(control.text), text) then
            self.collection:AddItem(control)
        end
    end

end

---------------------------------------------------------------------
--== private ===--
---------------------------------------------------------------------


function TriggerWindow:FillEffectCollection()

    self.collection:ClearItems()
    self.effect_controls = {}
    self.chat_controls = {}
    self.skill_controls = {}
    self.trigger_controls = {}

    local width = TRIGGERWINDOWCOLLECTION_WIDTH - 2

    self.collection:AddItem(self.effectsheader)
    for index, effect in ipairs(library["effects"]) do

        self.effect_controls[index] = EditHelpItem(width, effect["icon"], effect["name"], Turbine.UI.Color(0.1,0.1,0.1), effect["name"], self)
        self.collection:AddItem(self.effect_controls[index])
    end
    for i, effect in ipairs(collection["effects"]) do

        local index  = table.getn(self.effect_controls)+1
        self.effect_controls[index] = EditHelpItem(width, effect["icon"], effect["name"], Turbine.UI.Color(0.1,0.1,0.1), effect["name"], self)
        self.collection:AddItem(self.effect_controls[index])
    end

    local skill_list = lp:GetTrainedSkills()
    self.collection:AddItem(self.skillheader)
    for i=1, skill_list:GetCount(), 1 do
        local index  = table.getn(self.skill_controls)+1
        local s = skill_list:GetItem(i):GetSkillInfo()
        self.skill_controls[index] = EditHelpItem(width, s:GetIconImageID(), nil, Turbine.UI.Color(0.1,0.1,0.1), s:GetName(), self)
        self.collection:AddItem(self.skill_controls[index])        
    end

end


function TriggerWindow:FillChatCollection()

    self.collection:ClearItems()
    self.effect_controls = {}
    self.chat_controls = {}
    self.skill_controls = {}
    self.trigger_controls = {}

    local width = TRIGGERWINDOWCOLLECTION_WIDTH - 2

    self.collection:AddItem(self.chatheader)
    for index,chat in ipairs(library["chat"]) do

        self.chat_controls[index] = EditHelpItem(width, nil, chat["Args"]["Message"], Turbine.UI.Color(0.1,0.1,0.1), chat["Args"]["Message"], self)
        self.collection:AddItem(self.chat_controls[index])
    end
    for i,chat in ipairs(collection["chat"]) do
        local index  = table.getn(self.chat_controls)+1
        self.chat_controls[index] = EditHelpItem(width, nil, chat["Args"]["Message"], Turbine.UI.Color(0.1,0.1,0.1), chat["Args"]["Message"], self)
        self.collection:AddItem(self.chat_controls[index])
    end


    local skill_list = lp:GetTrainedSkills()
    self.collection:AddItem(self.skillheader)
    for i=1, skill_list:GetCount(), 1 do
        local index  = table.getn(self.skill_controls)+1
        local s = skill_list:GetItem(i):GetSkillInfo()
        self.skill_controls[index] = EditHelpItem(width, s:GetIconImageID(), nil, Turbine.UI.Color(0.1,0.1,0.1), s:GetName(), self)
        self.collection:AddItem(self.skill_controls[index])        
    end

end


function TriggerWindow:FillSkillCollection()

    self.collection:ClearItems()
    self.effect_controls = {}
    self.chat_controls = {}
    self.skill_controls = {}
    self.trigger_controls = {}

    local width = TRIGGERWINDOWCOLLECTION_WIDTH - 2

    local skill_list = lp:GetTrainedSkills()
    self.collection:AddItem(self.skillheader)
    for i=1, skill_list:GetCount(), 1 do
        local index  = table.getn(self.skill_controls)+1
        local s = skill_list:GetItem(i):GetSkillInfo()
        self.skill_controls[index] = EditHelpItem(width, s:GetIconImageID(), s:GetName(), Turbine.UI.Color(0.1,0.1,0.1), s:GetName(), self)
        self.collection:AddItem(self.skill_controls[index])        
    end

end


function TriggerWindow:FillTriggerCollection()

    self.collection:ClearItems()
    self.effect_controls = {}
    self.chat_controls = {}
    self.skill_controls = {}
    self.trigger_controls = {}

    local width = TRIGGERWINDOWCOLLECTION_WIDTH - 2

    local skill_list = lp:GetTrainedSkills()
    self.collection:AddItem(self.skillheader)
    for i=1, skill_list:GetCount(), 1 do
        local index  = table.getn(self.skill_controls)+1
        local s = skill_list:GetItem(i):GetSkillInfo()
        self.skill_controls[index] = EditHelpItem(width, s:GetIconImageID(), nil, Turbine.UI.Color(0.1,0.1,0.1), s:GetName(), self)
        self.collection:AddItem(self.skill_controls[index])        
    end

    self.collection:AddItem(self.triggerheader)
    for k=1, table.getn(windowdata), 1 do
        for j,list_name in ipairs(LIST_NAMES) do
            for i=1, table.getn(windowdata[k][list_name]), 1 do

                local item = windowdata[k][list_name][i]
                local index  = table.getn(self.trigger_controls)+1
                local text = item["description"]
                if text == "" or text == nil then
                    text = item["token"]
                end
                self.trigger_controls[index] = EditHelpItem(width, item["icon"], item["id"]..string.gsub(item["token"], "-", ""), Turbine.UI.Color(0.1,0.1,0.1), windowdata[k]["name"]..":\n["..text.."]", self)
                self.collection:AddItem(self.trigger_controls[index])
            end
        end
    end

end



function TriggerWindow:EmptyInformation()

    self.token:SetText("")
    self.description:SetText("")
    self.target_name:SetText("")

    self.icon:SetBackground()
    self.icon:SetBackColor(Turbine.UI.Color(0.3,0.3,0.3))
    
    self.icon_tb:SetText("")
    self.text_tb:SetText("")
    self.timer:SetText("")
    self.threshold:SetText("")
    self.popupspeed:SetText("")
    self.flashing:SetChecked(false)
    self.unique:SetChecked(false)
    self.loop:SetChecked(false)
    self.reset:SetChecked(false)

    self.reset:SetEnabled(true)


end

function TriggerWindow:FillInformation()

    self:EmptyInformation()

    if self.data["token"] ~= nil then
        self.token:SetText(self.data["token"])
    end

    if self.data["description"] ~= nil then
        self.description:SetText(self.data["description"])
    end
	
    if self.data["target_name"] ~= nil then
        self.target_name:SetText(self.data["target_name"])
    end
	
    if self.data["icon"] then
        self.icon:SetBackground(tonumber(self.data["icon"]))
        self.icon:SetBackColor()
    end

    if self.data["icon"] ~= nil then
        self.icon_tb:SetText(self.data["icon"])
    end

    if self.data["text"] ~= nil then
        self.text_tb:SetText(self.data["text"])
    end

    if self.data["timer"] ~= nil then
        self.timer:SetText(self.data["timer"])
    end

    if self.data["threshold"] ~= nil then
        self.threshold:SetText(self.data["threshold"])
    end

    if self.data["popup_multi"] ~= nil then
        self.popupspeed:SetText(self.data["popup_multi"])
    end

    if self.data["flashing"] ~= nil then
        self.flashing:SetChecked(self.data["flashing"])
    end

    if self.data["unique"] ~= nil then
        self.unique:SetChecked(self.data["unique"])
    end


    if self.data["loop"] ~= nil then
        self.loop:SetChecked(self.data["loop"])
    end

    if self.data["use_regex"] ~= nil then
        self.use_regex:SetChecked(self.data["use_regex"])
    end

    if self.data["hide_text"] ~= nil then
        self.hide_text:SetChecked(self.data["hide_text"])
    end


    if self.loop:IsChecked() then
        self.reset:SetEnabled(false)
        self.reset:SetChecked(true)
    else
        if self.data["reset"] ~= nil then
            self.reset:SetChecked(self.data["reset"])
        end
        self.reset:SetEnabled(true)
    end

    if self.data["protected"] ~= nil then
        self.protected:SetChecked(self.data["protected"])
    end

end

function TriggerWindow:SaveChanges()

    self.data["token"] = self.token:GetText()
    self.data["description"] = self.description:GetText()
    self.data["target_name"] = self.target_name:GetText()
    if self.icon_tb:GetText() == "" then
        self.data["icon"]= nil
    else
        self.data["icon"] = tonumber(self.icon_tb:GetText())
    end
    if self.text_tb:GetText() == "" then
        self.data["text"]= nil
    else
        self.data["text"]= self.text_tb:GetText()
    end
    self.data["timer"] = tonumber(self.timer:GetText())
    self.data["threshold"] = tonumber(self.threshold:GetText())
    self.data["popup_multi"] = tonumber(self.popupspeed:GetText())
    self.data["flashing"] = self.flashing:IsChecked()
    self.data["unique"] = self.unique:IsChecked()
    self.data["loop"] = self.loop:IsChecked()
    self.data["use_regex"] = self.use_regex:IsChecked()
    self.data["hide_text"] = self.hide_text:IsChecked()
    self.data["reset"] = self.reset:IsChecked()
    self.data["protected"] = self.protected:IsChecked()

    SaveSettings()

    self.parent:FillTrigger()

end

function TriggerWindow:Draw()

    self.trigger_tooltip = UI.Settings.Options.Tooltip()

    --== token ===--
    self.token = Turbine.UI.Lotro.TextBox()
	self.token:SetParent(self.foreground)
	self.token:SetSize(200,70)
	self.token:SetPosition(10,10)
	self.token:SetFont(Turbine.UI.Lotro.Font.Verdana12)
    self.token:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)

    self.name_l = Turbine.UI.Label()
    self.name_l:SetParent(self.foreground)
    self.name_l:SetSize(100, 25)
    self.name_l:SetPosition( 220, 10)
    self.name_l:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.name_l:SetFont(COMMENT_FONT)
    self.name_l:SetText(Utils.L[locale]["token"])
    self.name_l.MouseEnter = function()
        self.trigger_tooltip:SetTooltip(self.name_l, Utils.L[locale]["Tooltip"]["token"], 250,50,100,25)
    end
    self.name_l.MouseLeave = function()
        self.trigger_tooltip:RemoveTooltip()
    end

--== icon ===--
    self.icon = Turbine.UI.Control()
    self.icon:SetParent(self.foreground)
    self.icon:SetSize(32 ,32)
    self.icon:SetPosition(10, 85)
    self.icon:SetBackColor(Turbine.UI.Color(0.3,0.3,0.3))
    self.icon:SetVisible(true)
    self.icon:SetMouseVisible(false)

    self.icon_tb = Turbine.UI.Lotro.TextBox()
	self.icon_tb:SetParent(self.foreground)
	self.icon_tb:SetSize(158,25)
	self.icon_tb:SetPosition(52,90)
	self.icon_tb:SetFont(TB_FONT)
    self.icon_tb:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)

    self.icon_l = Turbine.UI.Label()
    self.icon_l:SetParent(self.foreground)
    self.icon_l:SetSize(100, 25)
    self.icon_l:SetPosition( 220, 90)
    self.icon_l:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.icon_l:SetFont(COMMENT_FONT)
    self.icon_l:SetText(Utils.L[locale]["icon"])

    --== text ===--
    self.text_tb = Turbine.UI.Lotro.TextBox()
    self.text_tb:SetParent(self.foreground)
    self.text_tb:SetSize(200,32)
    self.text_tb:SetPosition(10,127)
    self.text_tb:SetFont(TB_FONT)
    self.text_tb:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)

    self.text_l = Turbine.UI.Label()
    self.text_l:SetParent(self.foreground)
    self.text_l:SetSize(100, 25)
    self.text_l:SetPosition(220, 127)
    self.text_l:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.text_l:SetFont(COMMENT_FONT)
    self.text_l:SetText(Utils.L[locale]["text"])
    self.text_l.MouseEnter = function()
        self.trigger_tooltip:SetTooltip(self.text_l, Utils.L[locale]["Tooltip"]["text"], 250,110,100,25)
    end
    self.text_l.MouseLeave = function()
        self.trigger_tooltip:RemoveTooltip()
    end

    --== Timer ===--
    self.timer = Turbine.UI.Lotro.TextBox()
    self.timer:SetParent(self.foreground)
    self.timer:SetSize(50,25)
    self.timer:SetPosition(10, 167)
    self.timer:SetFont(TB_FONT)
    self.timer:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)


    --== Threshold ===--
    self.threshold = Turbine.UI.Lotro.TextBox()
    self.threshold:SetParent(self.foreground)
    self.threshold:SetSize(50,25)
    self.threshold:SetPosition(70,167)
    self.threshold:SetFont(TB_FONT)
    self.threshold:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)

    self.name_tt = Turbine.UI.Label()
    self.name_tt:SetParent(self.foreground)
    self.name_tt:SetSize(200, 25)
    self.name_tt:SetPosition(130, 167)
    self.name_tt:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.name_tt:SetFont(COMMENT_FONT)
    self.name_tt:SetText(Utils.L[locale]["timer"].." - "..Utils.L[locale]["threshold"])
    self.name_tt.MouseEnter = function()
        self.trigger_tooltip:SetTooltip(self.name_tt, Utils.L[locale]["Tooltip"]["timer_threshold"], 300,170,100,25)
    end
    self.name_tt.MouseLeave = function()
        self.trigger_tooltip:RemoveTooltip()
    end

    self.flashing =  Turbine.UI.Lotro.CheckBox()
	self.flashing:SetParent(self.foreground)
	self.flashing:SetSize(200, 25)
	self.flashing:SetPosition(15,197)
	self.flashing:SetFont(COMMENT_FONT)
    self.flashing:SetText(Utils.L[locale]["flashing"])
    self.flashing.MouseEnter = function()
        self.trigger_tooltip:SetTooltip(self.flashing, Utils.L[locale]["Tooltip"]["flashing"], 250,50,100,25)
    end
    self.flashing.MouseLeave = function()
        self.trigger_tooltip:RemoveTooltip()
    end

    self.unique =  Turbine.UI.Lotro.CheckBox()
	self.unique:SetParent(self.foreground)
	self.unique:SetSize(200, 25)
	self.unique:SetPosition(15,232)
	self.unique:SetFont(COMMENT_FONT)
    self.unique:SetText(Utils.L[locale]["unique"])
    self.unique.MouseEnter = function()
        self.trigger_tooltip:SetTooltip(self.unique, Utils.L[locale]["Tooltip"]["unique"], 250,55,100,25)
    end
    self.unique.MouseLeave = function()
        self.trigger_tooltip:RemoveTooltip()
    end

    --== popupspeed ===--
    self.popupspeed = Turbine.UI.Lotro.TextBox()
    self.popupspeed:SetParent(self.foreground)
    self.popupspeed:SetSize(50,25)
    self.popupspeed:SetPosition(110,232)
    self.popupspeed:SetFont(TB_FONT)
    self.popupspeed:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)

    self.name_pus = Turbine.UI.Label()
    self.name_pus:SetParent(self.foreground)
    self.name_pus:SetSize(200, 25)
    self.name_pus:SetPosition(170, 232)
    self.name_pus:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.name_pus:SetFont(COMMENT_FONT)
    self.name_pus:SetText(Utils.L[locale]["popup_multi"])
    self.name_pus.MouseEnter = function()
        self.trigger_tooltip:SetTooltip(self.name_pus, Utils.L[locale]["Tooltip"]["popup_multi"], 250,55,100,25)
    end
    self.name_pus.MouseLeave = function()
        self.trigger_tooltip:RemoveTooltip()
    end
    
    self.loop =  Turbine.UI.Lotro.CheckBox()
	self.loop:SetParent(self.foreground)
	self.loop:SetSize(200, 25)
	self.loop:SetPosition(15,267)
	self.loop:SetFont(COMMENT_FONT)
    self.loop:SetText(Utils.L[locale]["loop"])
    self.loop.MouseEnter = function()
        self.trigger_tooltip:SetTooltip(self.loop, Utils.L[locale]["Tooltip"]["loop"], 250,80,100,25)
    end
    self.loop.MouseLeave = function()
        self.trigger_tooltip:RemoveTooltip()
    end
    self.loop.CheckedChanged = function()

        if self.loop:IsChecked() then
            self.reset:SetEnabled(false)
            self.reset:SetChecked(true)
        else
            self.reset:SetChecked(false)
            self.reset:SetEnabled(true)
        end

    end

    
    self.reset =  Turbine.UI.Lotro.CheckBox()
	self.reset:SetParent(self.foreground)
	self.reset:SetSize(200, 25)
	self.reset:SetPosition(130,267)
	self.reset:SetFont(COMMENT_FONT)
    self.reset:SetText(Utils.L[locale]["reset"])
    self.reset.MouseEnter = function()
        self.trigger_tooltip:SetTooltip(self.reset, Utils.L[locale]["Tooltip"]["reset"], 250,50,100,25)
    end
    self.reset.MouseLeave = function()
        self.trigger_tooltip:RemoveTooltip()
    end

    self.protected =  Turbine.UI.Lotro.CheckBox()
	self.protected:SetParent(self.foreground)
	self.protected:SetSize(200, 25)
	self.protected:SetPosition(130,197)
	self.protected:SetFont(COMMENT_FONT)
    self.protected:SetText(Utils.L[locale]["protected"])
    self.protected.MouseEnter = function()
        self.trigger_tooltip:SetTooltip(self.protected, Utils.L[locale]["Tooltip"]["protected"], 250,50,100,25)
    end
    self.protected.MouseLeave = function()
        self.trigger_tooltip:RemoveTooltip()
    end

    
    self.use_regex =  Turbine.UI.Lotro.CheckBox()
	self.use_regex:SetParent(self.foreground)
	self.use_regex:SetSize(200, 25)
	self.use_regex:SetPosition(15,302)
	self.use_regex:SetFont(COMMENT_FONT)
    self.use_regex:SetText(Utils.L[locale]["use_regex"])
    self.use_regex.MouseEnter = function()
        self.trigger_tooltip:SetTooltip(self.use_regex, Utils.L[locale]["Tooltip"]["use_regex"], 250,50,100,25)
    end
    self.use_regex.MouseLeave = function()
        self.trigger_tooltip:RemoveTooltip()
    end

    
    self.hide_text =  Turbine.UI.Lotro.CheckBox()
	self.hide_text:SetParent(self.foreground)
	self.hide_text:SetSize(200, 25)
	self.hide_text:SetPosition(130,302)
	self.hide_text:SetFont(COMMENT_FONT)
    self.hide_text:SetText(Utils.L[locale]["hide_text"])
    self.hide_text.MouseEnter = function()
        self.trigger_tooltip:SetTooltip(self.hide_text, Utils.L[locale]["Tooltip"]["hide_text"], 250,50,100,25)
    end
    self.hide_text.MouseLeave = function()
        self.trigger_tooltip:RemoveTooltip()
    end

    --== target_name ===--
    self.target_name = Turbine.UI.Lotro.TextBox()
	self.target_name:SetParent(self.foreground)
	self.target_name:SetSize(200,32)
	self.target_name:SetPosition(10,332)
	self.target_name:SetFont(TB_FONT)
    self.target_name:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)

    self.target_name_l = Turbine.UI.Label()
    self.target_name_l:SetParent(self.foreground)
    self.target_name_l:SetSize(100, 25)
    self.target_name_l:SetPosition( 220, 337)
    self.target_name_l:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.target_name_l:SetFont(COMMENT_FONT)
    self.target_name_l:SetText(Utils.L[locale]["target_name"])
    self.target_name_l.MouseEnter = function()
        self.trigger_tooltip:SetTooltip(self.target_name_l, Utils.L[locale]["Tooltip"]["target_name"], 250,65,100,25)
    end
    self.target_name_l.MouseLeave = function()
        self.trigger_tooltip:RemoveTooltip()
    end
    
    --== description ===--
    self.description = Turbine.UI.Lotro.TextBox()
	self.description:SetParent(self.foreground)
	self.description:SetSize(200,32)
	self.description:SetPosition(10,369)
	self.description:SetFont(TB_FONT)
    self.description:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)

    self.description_l = Turbine.UI.Label()
    self.description_l:SetParent(self.foreground)
    self.description_l:SetSize(100, 25)
    self.description_l:SetPosition( 220, 371)
    self.description_l:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.description_l:SetFont(COMMENT_FONT)
    self.description_l:SetText(Utils.L[locale]["description"])
    self.description_l.MouseEnter = function()
        self.trigger_tooltip:SetTooltip(self.description_l, Utils.L[locale]["Tooltip"]["description"], 250,50,100,25)
    end
    self.description_l.MouseLeave = function()
        self.trigger_tooltip:RemoveTooltip()
    end
    

    self.delete_button = Turbine.UI.Lotro.Button()
    self.delete_button:SetParent(self.foreground)
    self.delete_button:SetPosition(10, self.foreground:GetHeight() - 30)
    self.delete_button:SetSize(80,20)
    self.delete_button:SetText("Delete")
    self.delete_button:SetVisible(true)

    self.delete_button.Click = function(sender, args)
        self.parent:DeleteTrigger(self.data)
        self:SaveChanges()
        self:Close()
    end
    
    self.accept_button = Turbine.UI.Lotro.Button()
    self.accept_button:SetParent(self.foreground)
    self.accept_button:SetPosition(self.foreground:GetWidth() - 90, self.foreground:GetHeight() - 30)
    self.accept_button:SetSize(80,20)
    self.accept_button:SetText("Accept")
    self.accept_button:SetVisible(true)

    self.accept_button.Click = function(sender, args)
        self:SaveChanges()
        self:Close()

        if self.data["type"] == 1 then
            --Trigger.AddEffectEvents()
        elseif self.data["type"] == 2 then
            --Trigger.AddEffectEvents()
        elseif self.data["type"] == 3 then
            --Trigger.AddEffectEvents()
        elseif self.data["type"] == 4 then
        elseif self.data["type"] == 5 then
            Trigger.checkAllSkills()
        elseif self.data["type"] == 6 then
        else
        end

    end

end

function TriggerWindow:Closed()
    self.parent:CloseTriggerWindow()
end

function TriggerWindow:Resize()

end


---------------------------------------------------------------------
--=====--
---------------------------------------------------------------------
-- Item
---------------------------------------------------------------------
--=====--
---------------------------------------------------------------------

EditHelpItem = class( Turbine.UI.Control )

function EditHelpItem:Constructor(width ,icon, token, color, text, parent)
    Turbine.UI.Control.Constructor( self )
    
    local height = 48
    self:SetSize(width, height + 2)

    self.parent = parent

    self.color = color
    self.token = token
    self.duration = duration
    self.iconID = icon
    self.text = text

    self.icon = Turbine.UI.Control()
    self.icon:SetParent(self)
    self.icon:SetPosition(3, 5)
    self.icon:SetMouseVisible(false)
    self.icon:SetSize(32,32)
    if icon == nil then
        self.icon:SetBackColor(Turbine.UI.Color(0.3,0.3,0.3))
    else
        self.icon:SetBackground(tonumber(icon))
    end
    
    self.icon:SetZOrder(4)

    self.background = Turbine.UI.Control()
    self.background:SetParent(self)
    self.background:SetPosition(1, 3)
	self.background:SetSize(width - 2, height)
	self.background:SetMouseVisible(false)
    self.background:SetBackColor(color)
    self.background:SetZOrder(2)
    self.background:SetVisible(true)


    self.text_label = Turbine.UI.Label()
	self.text_label:SetParent(self.background)
	self.text_label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.text_label:SetMouseVisible(false)
    self.text_label:SetLeft(35)
    self.text_label:SetWidth(self.background:GetWidth()-36)
    self.text_label:SetHeight(self.background:GetHeight())
	self.text_label:SetFont(Turbine.UI.Lotro.Font.Verdana12)
    self.text_label:SetText(text)

    self.MouseEnter = function(sender, args)

        self.background:SetBackColor(Turbine.UI.Color(0.3,0.3,0.3))

	end
	
	self.MouseLeave = function(sender, args)

        self.background:SetBackColor(self.color)

    end

    function self:MouseClick(sender, args)

        self.parent:ControlClicked(self.token, self.iconID, self.duration)

    end

end