OPTIONSWINDOWLEFT = 220
OPTIONSLEFT = 230
LISTBOXWIDTH = 200
COMMENT_FONT = Turbine.UI.Lotro.Font.Verdana14

Window = class( Turbine.UI.Window )

function Window:Constructor()
    Turbine.UI.Window.Constructor( self )

    self.data = windowdata["settings"]
    self.selected_window_index = nil
    self.windows_controls = {}
    self.group_controls = {}
    self.trigger_controls = {}
    
    self.trigger_window = nil
    self.export_window = nil
    self:SetSize(self.data["width"] + OPTIONSWINDOWLEFT+10, self.data["height"] + 30)
    self:SetPosition(self.data["left"], self.data["top"])
    self:SetMouseVisible(false)

    self.back = UI.Settings.BaseWindow(self.data["width"], self.data["height"],  OPTIONSWINDOWLEFT,  0, Turbine.UI.Color.White, Turbine.UI.Color.Black, Utils.L[locale]["header"]["options"], self, 550, 450, 550, nil)
    self.back:ChangeVisiblility(true)

    self.foreground = Turbine.UI.Window()
    self.foreground:SetParent(self)
    self.foreground:SetPosition(OPTIONSWINDOWLEFT + OPTIONSLEFT, 25)
    self.foreground:SetSize(self:GetWidth() - (OPTIONSWINDOWLEFT + OPTIONSLEFT) - 5, self.data["height"])
    self.foreground:SetVisible(true)
    self.foreground:SetZOrder(10)

    self.foreground.FillSelected = function()end

    self.windows = UI.Settings.BaseListBox(LISTBOXWIDTH , self.data["height"] -6, 0, 26, Turbine.UI.Color.White, Turbine.UI.Color.Black, Utils.L[locale]["header"]["windows"], self, true)
    self.windows:ChangeVisiblility(true)
    self.windows:SetZOrder(4)

    self.new_window_menu = Turbine.UI.ContextMenu()
    self.new_window_items = self.new_window_menu:GetItems()

    self.new_winodw = Turbine.UI.MenuItem( Utils.L[locale]["context_menu"]["window"], true )
    self.new_group = Turbine.UI.MenuItem(  Utils.L[locale]["context_menu"]["group"], true )

    self.new_winodw.Click = function(sender, args)
        local index = AddNewWindow()
        self:FillWindows()
        self:WindowSelectionChanged(index)
    end

    self.new_group.Click = function(sender, args)

        GroupNameWindow(self, nil)

    end


    self.new_window_items:Add( self.new_winodw )
    self.new_window_items:Add( self.new_group )

    self.windows_loaded_header = Turbine.UI.Label()
    self.windows_loaded_header:SetSize(LISTBOXWIDTH, 20)
    self.windows_loaded_header:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.windows_loaded_header:SetFont(Turbine.UI.Lotro.Font.Verdana18)
    self.windows_loaded_header:SetText(Utils.L[locale]["header"]["loaded"])
    self.windows_loaded_header:SetForeColor(Turbine.UI.Color.White)

    self.collapse_all_button = Turbine.UI.Button()
    self.collapse_all_button:SetParent(self.windows_loaded_header)
    self.collapse_all_button:SetSize(16, 15)
    self.collapse_all_button:SetPosition(LISTBOXWIDTH - 33, 2)
    self.collapse_all_button:SetBackColor(Turbine.UI.Color(0.2,0.2,0.2))
    self.collapse_all_button:SetVisible(true)
    self.collapse_all_button:SetMouseVisible(true)
    self.collapse_all_button:SetText("-")

    self.collapse_all_button.Click = function()
        for k,v in ipairs(self.group_controls) do
            if v.data["collapse"] == false then
                v:CollapsedChanged()
            end
        end
    end

    self.collapse_all_button.MouseLeave = function()
        self.collapse_all_button:SetBackColor(Turbine.UI.Color(0.2,0.2,0.2))
    end

    self.collapse_all_button.MouseEnter = function()
        self.collapse_all_button:SetBackColor(Turbine.UI.Color.Black)
    end

    self.anti_collapse_all_button = Turbine.UI.Button()
    self.anti_collapse_all_button:SetParent(self.windows_loaded_header)
    self.anti_collapse_all_button:SetSize(15, 15)
    self.anti_collapse_all_button:SetPosition(LISTBOXWIDTH - 53, 2)
    self.anti_collapse_all_button:SetBackColor(Turbine.UI.Color(0.2,0.2,0.2))
    self.anti_collapse_all_button:SetVisible(true)
    self.anti_collapse_all_button:SetMouseVisible(true)
    self.anti_collapse_all_button:SetText("+")

    self.anti_collapse_all_button.Click = function()
        for k,v in ipairs(self.group_controls) do
            if v.data["collapse"] == true then
                v:CollapsedChanged()
            end
        end
    end

    self.anti_collapse_all_button.MouseLeave = function()
        self.anti_collapse_all_button:SetBackColor(Turbine.UI.Color(0.2,0.2,0.2))
    end

    self.anti_collapse_all_button.MouseEnter = function()
        self.anti_collapse_all_button:SetBackColor(Turbine.UI.Color.Black)
    end

    
    --self.collapse.Click = function()
       -- self:CollapsedChanged()
    --end

    self.windows_notloaded_header = Turbine.UI.Label()
    self.windows_notloaded_header:SetSize(LISTBOXWIDTH, 20)
    self.windows_notloaded_header:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.windows_notloaded_header:SetFont(Turbine.UI.Lotro.Font.Verdana18)
    self.windows_notloaded_header:SetText(Utils.L[locale]["header"]["not_loaded"])
    self.windows_notloaded_header:SetForeColor(Turbine.UI.Color.White)

    self.trigger = UI.Settings.BaseListBox(LISTBOXWIDTH, self.data["height"] - 12, OPTIONSWINDOWLEFT + 6, 26, Turbine.UI.Color.White,  Turbine.UI.Color.Black, Utils.L[locale]["header"]["triggers"], self, true)
    self.trigger:ChangeVisiblility(true)
    self.trigger:SetZOrder(6)

    self.new_effect_s = Turbine.UI.MenuItem( Utils.L[locale]["context_menu"]["effect_s"], true )
    self.new_effect_g = Turbine.UI.MenuItem( Utils.L[locale]["context_menu"]["effect_g"], true )
    self.new_effect_t = Turbine.UI.MenuItem( Utils.L[locale]["context_menu"]["effect_t"], true )
    self.new_chat = Turbine.UI.MenuItem( Utils.L[locale]["context_menu"]["chat"], true )
    self.new_skill = Turbine.UI.MenuItem( Utils.L[locale]["context_menu"]["skill"], true )
    self.new_trigger_e = Turbine.UI.MenuItem( Utils.L[locale]["context_menu"]["trigger_e"], true )
    self.new_trigger_s = Turbine.UI.MenuItem(Utils.L[locale]["context_menu"]["trigger_s"], true )
    self.new_trigger_t = Turbine.UI.MenuItem( Utils.L[locale]["context_menu"]["trigger_t"], true )

    self.new_menu = Turbine.UI.ContextMenu()
    self.new_items = self.new_menu:GetItems()

    self.new_items:Add( self.new_effect_s )
    self.new_items:Add( self.new_effect_g )
    self.new_items:Add( self.new_effect_t )
    self.new_items:Add( self.new_chat )
    self.new_items:Add( self.new_skill)
    self.new_items:Add( self.new_trigger_e)
    self.new_items:Add( self.new_trigger_s)
    self.new_items:Add( self.new_trigger_t)

    self.new_effect_s.Click = function(sender, args)
        self:ShowTriggerWindow(addtowindow_NewEffectSelf(windowdata[self.selected_window_index]))
        self:FillTrigger()
    end
    self.new_effect_g.Click = function(sender, args)
        self:ShowTriggerWindow(addtowindow_NewEffectGroup(windowdata[self.selected_window_index]))
        if windowdata["track_effects_group"] then
            Trigger.AddGroupEffectEvents()
        end
        self:FillTrigger()
    end
    self.new_effect_t.Click = function(sender, args)
        self:ShowTriggerWindow(addtowindow_NewEffectTarget(windowdata[self.selected_window_index]))
        if windowdata["track_effects_target"] then
            Trigger.AddEventTargetEffects()
        end
        self:FillTrigger()
    end
    self.new_chat.Click = function(sender, args)
        self:ShowTriggerWindow(addtowindow_NewChat(windowdata[self.selected_window_index]))
        self:FillTrigger()
    end
    self.new_skill.Click = function(sender, args)
        self:ShowTriggerWindow(addtowindow_NewSkill(windowdata[self.selected_window_index]))
        self:FillTrigger()
    end
    self.new_trigger_e.Click = function(sender, args)
        self:ShowTriggerWindow(addtowindow_NewTrigger_End(windowdata[self.selected_window_index]))
        self:FillTrigger()
    end
    self.new_trigger_s.Click = function(sender, args)
        self:ShowTriggerWindow(addtowindow_NewTrigger_Start(windowdata[self.selected_window_index]))
        self:FillTrigger()
    end
    self.new_trigger_t.Click = function(sender, args)
        self:ShowTriggerWindow(addtowindow_NewTrigger_Threshold(windowdata[self.selected_window_index]))
        self:FillTrigger()
    end

    self.group_selection = Turbine.UI.ContextMenu()
    self.group_selection_items = self.group_selection:GetItems()

    self:FillGroupContextMenu()

    self:SetWantsKeyEvents(true)

    self.KeyDown = function(sender, args)
        if args.Action == 145 then
            self.back:Close()
        end
    end

    self:DrawOptions()

    self:FillWindows()
    self:FillTrigger()

    self:EnableOptions(false)
    self:SetVisible(true)

end

---------------------------------------------------------------------
--== public ===--
---------------------------------------------------------------------

-- function Window:Reload_After_Groupchanges()

--     self.reload_after_groupchanges:SetChecked(windowdata["reload_after_groupchanges"])

-- end

function Window:CloseGrouNameWindow()
    self.groupname_popup = nil
end

function Window:FillGroupContextMenu()

    self.group_selection_items:Clear()

    for k,v in ipairs(windowdata["window_groups"]) do

        local item = Turbine.UI.MenuItem( v["name"], true )

        item.Click = function(sender,args)
            self.addToGroupItem.data["group"] = v["id"]
            self:FillWindows()
            SaveSettings()
        end

        self.group_selection_items:Add( item )
        
    end
end

function Window:EnableOptions(switch)

    self.trigger:SetEnabled(switch)
    self.selectType:SetEnabled(switch)
    self.name_tb:SetEnabled(switch)
    self.width:SetEnabled(switch)
    self.height:SetEnabled(switch)
    self.spacing:SetEnabled(switch)
    self.ascending:SetEnabled(switch)
    self.orientation_horizontal:SetEnabled(switch)
    self.selectFont:SetEnabled(switch)
    self.frame_tb:SetEnabled(switch)
    self.opacity_tb:SetEnabled(switch)
    self.opacity2_tb:SetEnabled(switch)
    self.export_button:SetEnabled(switch)

end

function Window:FilterContent(text, control)

    if control == self.windows then
        self:FilterWindows(text)
    elseif control == self.trigger then
        self:FilterTrigger(text)
    end

end

function Window:NewButtonPressed(control)

    if control == self.windows then
        self:NewWindowButtonPressed()
    elseif control == self.trigger then
        self:NewTriggerButtonPressed()
    end

end

function Window:ShowExport()
    self.export_window:ShowExport_Window(windowdata[self.selected_window_index])
end

function Window:ShowExport_Trigger(data)
    self:ShowExportWindow()
    self.export_window:ShowExport_Trigger(data)
end

function Window:ShowExport_Group(id, name)
    self:ShowExportWindow()
    
    local datalist = {}
    for i=1, table.getn(windowdata), 1 do
        if windowdata[i]["group"] == id then
            datalist[table.getn(datalist) + 1] = windowdata[i]
        end
    end

    self.export_window:ShowExport_Group(name, datalist)
end

function Window:ShowImport()
    self.export_window:ShowImport()
end

---------------------------------------------------------------------
--== private ===--
---------------------------------------------------------------------


function Window:Closed()
    if self.trigger_window ~= nil then
        self.trigger_window:Close()
    end
    if self.export_window ~= nil then
        self.export_window:Close()
    end

    self.back:Close()

    settings_Close(false)
end

function Window:DrawOptions()

    self.window_tooltip = UI.Settings.Options.Tooltip()

    --== Type ===--
	self.selectType = UI.Settings.LabelledComboBox(nil, nil, 160)
	self.selectType:SetParent(self.foreground)
    self.selectType:SetPosition(0,10)
    self.selectType:AddItem(Utils.L[locale]["bar_listbox"], 1);
    self.selectType:AddItem(Utils.L[locale]["bar_window"], 2);
    self.selectType:AddItem(Utils.L[locale]["icon_listbox"], 3);
    self.selectType:AddItem(Utils.L[locale]["icon_window"], 4);
    self.selectType:SetZOrder(10)

    self.select_l = Turbine.UI.Label()
    self.select_l:SetParent(self.foreground)
    self.select_l:SetSize(200, 20)
    self.select_l:SetPosition( 170, 10)
    self.select_l:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.select_l:SetFont(COMMENT_FONT)
    self.select_l:SetText(Utils.L[locale]["window_type"])
    self.select_l:SetForeColor(Turbine.UI.Color.White)
    self.select_l.MouseEnter = function()
        self.window_tooltip:SetTooltip(self.select_l, Utils.L[locale]["Tooltip"]["window_type"], 250,125,100,25)
    end
    self.select_l.MouseLeave = function()
        self.window_tooltip:RemoveTooltip()
    end

--== Name ===--
    self.name_tb = Turbine.UI.Lotro.TextBox()
	self.name_tb:SetParent(self.foreground)
	self.name_tb:SetSize(200,25)
	self.name_tb:SetPosition(0,50)
	self.name_tb:SetFont(TB_FONT)
    self.name_tb:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)

    self.name_l = Turbine.UI.Label()
    self.name_l:SetParent(self.foreground)
    self.name_l:SetSize(100, 25)
    self.name_l:SetPosition(210, 50)
    self.name_l:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.name_l:SetFont(COMMENT_FONT)
    self.name_l:SetText(Utils.L[locale]["name"])
    self.name_l:SetForeColor(Turbine.UI.Color.White)
    
--== Width ===--
    self.width = Turbine.UI.Lotro.TextBox()
	self.width:SetParent(self.foreground)
	self.width:SetSize(50,25)
	self.width:SetPosition(0, 80)
	self.width:SetFont(TB_FONT)
	self.width:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)

    
--== Height ===--
	self.height = Turbine.UI.Lotro.TextBox()
	self.height:SetParent(self.foreground)
	self.height:SetSize(50,25)
	self.height:SetPosition(60,80)
	self.height:SetFont(TB_FONT)
    self.height:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)


    
    self.name_wh = Turbine.UI.Label()
    self.name_wh:SetParent(self.foreground)
    self.name_wh:SetSize(200, 25)
    self.name_wh:SetPosition(120, 80)
    self.name_wh:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.name_wh:SetFont(COMMENT_FONT)
    self.name_wh:SetText(Utils.L[locale]["width_height"])
    self.name_wh:SetForeColor(Turbine.UI.Color.White)

    
--== Spacing ===--
	self.spacing = Turbine.UI.Lotro.TextBox()
	self.spacing:SetParent(self.foreground)
	self.spacing:SetSize(50,25)
	self.spacing:SetPosition(0,110)
	self.spacing:SetFont(TB_FONT)
	self.spacing:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)

    self.name_st = Turbine.UI.Label()
    self.name_st:SetParent(self.foreground)
    self.name_st:SetSize(200, 25)
    self.name_st:SetPosition(120, 110)
    self.name_st:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.name_st:SetFont(COMMENT_FONT)
    self.name_st:SetText(Utils.L[locale]["spacing"])
    self.name_st:SetForeColor(Turbine.UI.Color.White)

        
    --== Frame ===--
    self.frame_tb = Turbine.UI.Lotro.TextBox()
    self.frame_tb:SetParent(self.foreground)
    self.frame_tb:SetSize(50,25)
    self.frame_tb:SetPosition(60, 110)
    self.frame_tb:SetFont(TB_FONT)
    self.frame_tb:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)

    
--== Font ===--
	self.selectFont = UI.Settings.LabelledComboBox(nil, nil, 160)
	self.selectFont:SetParent(self.foreground)
	self.selectFont:SetPosition(0,142)
	self.selectFont:AddItem("Arial 12", 1);
	self.selectFont:AddItem("TrajanPro 13", 2);
	self.selectFont:AddItem("TrajanPro 14", 3);
	self.selectFont:AddItem("TrajanPro 15", 4);
	self.selectFont:AddItem("TrajanPro 16", 5);
	self.selectFont:AddItem("TrajanPro 18", 6);
	self.selectFont:AddItem("TrajanPro 19", 7);
	self.selectFont:AddItem("TrajanPro 20", 8);
	self.selectFont:AddItem("TrajanPro 21", 9);
	self.selectFont:AddItem("TrajanPro 23", 10);
	self.selectFont:AddItem("TrajanPro 24", 11);
	self.selectFont:AddItem("TrajanPro 25", 12);
	self.selectFont:AddItem("TrajanPro 26", 13);
	self.selectFont:AddItem("TrajanPro 28", 14);
	self.selectFont:AddItem("TrajanProBold 16", 15);
	self.selectFont:AddItem("TrajanProBold 22", 16);
	self.selectFont:AddItem("TrajanProBold 24", 17);
	self.selectFont:AddItem("TrajanProBold 25", 18);
	self.selectFont:AddItem("TrajanProBold 30", 19);
	self.selectFont:AddItem("TrajanProBold 36", 20);
	self.selectFont:AddItem("Verdana 10", 21);
	self.selectFont:AddItem("Verdana 12", 22);
	self.selectFont:AddItem("Verdana 14", 23);
	self.selectFont:AddItem("Verdana 16", 24);
	self.selectFont:AddItem("Verdana 18", 25);
	self.selectFont:AddItem("Verdana 20", 26);
	self.selectFont:AddItem("Verdana 22", 27);
    self.selectFont:AddItem("Verdana 23", 28);

    self.font_l = Turbine.UI.Label()
    self.font_l:SetParent(self.foreground)
    self.font_l:SetSize(200, 20)
    self.font_l:SetPosition(170, 142)
    self.font_l:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.font_l:SetFont(COMMENT_FONT)
    self.font_l:SetText(Utils.L[locale]["font"])
    self.font_l:SetForeColor(Turbine.UI.Color.White)

    
--== Opacity ===--
	self.opacity2_tb = Turbine.UI.Lotro.TextBox()
	self.opacity2_tb:SetParent(self.foreground)
	self.opacity2_tb:SetSize(50,25)
	self.opacity2_tb:SetPosition(0,170)
	self.opacity2_tb:SetFont(TB_FONT)
    self.opacity2_tb:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)

    --== Opacity ===--
	self.opacity_tb = Turbine.UI.Lotro.TextBox()
	self.opacity_tb:SetParent(self.foreground)
	self.opacity_tb:SetSize(50,25)
	self.opacity_tb:SetPosition(60,170)
	self.opacity_tb:SetFont(TB_FONT)
    self.opacity_tb:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    
    self.name_fo = Turbine.UI.Label()
    self.name_fo:SetParent(self.foreground)
    self.name_fo:SetSize(200, 25)
    self.name_fo:SetPosition(120, 170)
    self.name_fo:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.name_fo:SetFont(COMMENT_FONT)
    self.name_fo:SetText(Utils.L[locale]["frame_trans"])
    self.name_fo:SetForeColor(Turbine.UI.Color.White)
    self.name_fo.MouseEnter = function()
        self.window_tooltip:SetTooltip(self.name_fo, Utils.L[locale]["Tooltip"]["opacity"], 200,50,100,25)
    end
    self.name_fo.MouseLeave = function()
        self.window_tooltip:RemoveTooltip()
    end

    --== frame-color ===--
	self.frame_color = Turbine.UI.Lotro.TextBox()
	self.frame_color:SetParent(self.foreground)
	self.frame_color:SetSize(110,25)
	self.frame_color:SetPosition(0,200)
	self.frame_color:SetFont(TB_FONT)
    self.frame_color:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    
    self.name_fco = Turbine.UI.Label()
    self.name_fco:SetParent(self.foreground)
    self.name_fco:SetSize(200, 25)
    self.name_fco:SetPosition(120, 200)
    self.name_fco:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.name_fco:SetFont(COMMENT_FONT)
    self.name_fco:SetText(Utils.L[locale]["frame_color"])
    self.name_fco:SetForeColor(Turbine.UI.Color.White)
    self.name_fco.MouseEnter = function()
        self.window_tooltip:SetTooltip(self.name_fco, Utils.L[locale]["Tooltip"]["frame_color"], 200,50,100,25)
    end
    self.name_fco.MouseLeave = function()
        self.window_tooltip:RemoveTooltip()
    end

    --== back-color ===--
	self.back_color = Turbine.UI.Lotro.TextBox()
	self.back_color:SetParent(self.foreground)
	self.back_color:SetSize(110,25)
	self.back_color:SetPosition(0,230)
	self.back_color:SetFont(TB_FONT)
    self.back_color:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    
    self.name_bco = Turbine.UI.Label()
    self.name_bco:SetParent(self.foreground)
    self.name_bco:SetSize(200, 25)
    self.name_bco:SetPosition(120, 230)
    self.name_bco:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.name_bco:SetFont(COMMENT_FONT)
    self.name_bco:SetText(Utils.L[locale]["back_color"])
    self.name_bco:SetForeColor(Turbine.UI.Color.White)
    self.name_bco.MouseEnter = function()
        self.window_tooltip:SetTooltip(self.name_bco, Utils.L[locale]["Tooltip"]["back_color"], 200,50,100,25)
    end
    self.name_bco.MouseLeave = function()
        self.window_tooltip:RemoveTooltip()
    end

    --== bar-color ===--
	self.bar_color = Turbine.UI.Lotro.TextBox()
	self.bar_color:SetParent(self.foreground)
	self.bar_color:SetSize(110,25)
	self.bar_color:SetPosition(0,260)
	self.bar_color:SetFont(TB_FONT)
    self.bar_color:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    
    self.name_baco = Turbine.UI.Label()
    self.name_baco:SetParent(self.foreground)
    self.name_baco:SetSize(200, 25)
    self.name_baco:SetPosition(120, 260)
    self.name_baco:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.name_baco:SetFont(COMMENT_FONT)
    self.name_baco:SetText(Utils.L[locale]["bar_color"])
    self.name_baco:SetForeColor(Turbine.UI.Color.White)
    self.name_baco.MouseEnter = function()
        self.window_tooltip:SetTooltip(self.name_baco, Utils.L[locale]["Tooltip"]["bar_color"], 200,50,100,25)
    end
    self.name_baco.MouseLeave = function()
        self.window_tooltip:RemoveTooltip()
    end

    self.ascending =  Turbine.UI.Lotro.CheckBox()
	self.ascending:SetParent(self.foreground)
    self.ascending:SetSize(120, 25)
    self.ascending:SetFont(COMMENT_FONT)
    self.ascending:SetText(Utils.L[locale]["ascending"])
    self.ascending:SetPosition(0, 290)
    self.ascending.MouseEnter = function()
        self.window_tooltip:SetTooltip(self.ascending, Utils.L[locale]["Tooltip"]["ascending"], 200,50,100,25)
    end
    self.ascending.MouseLeave = function()
        self.window_tooltip:RemoveTooltip()
    end

    self.orientation_horizontal =  Turbine.UI.Lotro.CheckBox()
	self.orientation_horizontal:SetParent(self.foreground)
    self.orientation_horizontal:SetSize(120, 25)
    self.orientation_horizontal:SetFont(COMMENT_FONT)
    self.orientation_horizontal:SetText(Utils.L[locale]["orientation"])
	self.orientation_horizontal:SetPosition(100, 290)
    self.orientation_horizontal.MouseEnter = function()
        self.window_tooltip:SetTooltip(self.orientation_horizontal, Utils.L[locale]["Tooltip"]["orientation"], 200,50,100,25)
    end
    self.orientation_horizontal.MouseLeave = function()
        self.window_tooltip:RemoveTooltip()
    end




    self.track_target =  Turbine.UI.Lotro.CheckBox()
	self.track_target:SetParent(self.foreground)
	self.track_target:SetSize(200, 25)
	self.track_target:SetPosition(120, self.foreground:GetHeight() - 95)
	self.track_target:SetFont(COMMENT_FONT)
    self.track_target:SetText(Utils.L[locale]["track_target"])  
    self.track_target:SetChecked(windowdata["track_effects_target"])
    self.track_target:SetForeColor(Turbine.UI.Color.White)
    self.track_target.CheckedChanged = function(sender, args)
        windowdata["track_effects_target"] = self.track_target:IsChecked()
        SaveSettings()

        TrackTargetChanged()

    end
    self.track_target.MouseEnter = function()
        self.window_tooltip:SetTooltip(self.track_target, Utils.L[locale]["Tooltip"]["track_target"], 250,55,100,25)
    end
    self.track_target.MouseLeave = function()
        self.window_tooltip:RemoveTooltip()
    end

    self.track_group =  Turbine.UI.Lotro.CheckBox()
	self.track_group:SetParent(self.foreground)
	self.track_group:SetSize(200, 25)
	self.track_group:SetPosition(120, self.foreground:GetHeight() - 70)
	self.track_group:SetFont(COMMENT_FONT)
    self.track_group:SetText(Utils.L[locale]["track_group"])
    self.track_group:SetChecked(windowdata["track_effects_group"])
    self.track_group:SetForeColor(Turbine.UI.Color.White)
    self.track_group.CheckedChanged = function(sender, args)
        windowdata["track_effects_group"] = self.track_group:IsChecked()
        SaveSettings()

        TrackGroupChanged()

    end
    self.track_group.MouseEnter = function()
        self.window_tooltip:SetTooltip(self.track_group, Utils.L[locale]["Tooltip"]["track_group"], 250,70,100,25)
    end
    self.track_group.MouseLeave = function()
        self.window_tooltip:RemoveTooltip()
    end

    -- self.reload_after_groupchanges =  Turbine.UI.Lotro.CheckBox()
	-- self.reload_after_groupchanges:SetParent(self.foreground)
	-- self.reload_after_groupchanges:SetSize(200, 25)
	-- self.reload_after_groupchanges:SetPosition(250, self.foreground:GetHeight() - 95)
	-- self.reload_after_groupchanges:SetFont(COMMENT_FONT)
    -- self.reload_after_groupchanges:SetText(" reload_after groupchanges")  
    -- self.reload_after_groupchanges:SetChecked(windowdata["reload_after_groupchanges"])
    -- self.reload_after_groupchanges:SetForeColor(Turbine.UI.Color.White)
    -- self.reload_after_groupchanges.CheckedChanged = function(sender, args)

    --     reload_after_groupchanges_Changed(self.reload_after_groupchanges:IsChecked())

    -- end


    self.show_tooltips =  Turbine.UI.Lotro.CheckBox()
	self.show_tooltips:SetParent(self.foreground)
	self.show_tooltips:SetSize(200, 25)
	self.show_tooltips:SetPosition(220, self.foreground:GetHeight() - 70)
	self.show_tooltips:SetFont(COMMENT_FONT)
    self.show_tooltips:SetText(Utils.L[locale]["show_tooltips"])
    if windowdata["settings"]["show_tooltips"] == false then
        self.show_tooltips:SetChecked(false)
    else
        self.show_tooltips:SetChecked(true)
    end
    self.show_tooltips:SetForeColor(Turbine.UI.Color.White)
    self.show_tooltips.CheckedChanged = function(sender, args)
        windowdata["settings"]["show_tooltips"] = self.show_tooltips:IsChecked()
        SaveSettings()
    end

    self.export_button = Turbine.UI.Lotro.Button()
    self.export_button:SetParent(self.foreground)
    self.export_button:SetPosition(0, self.foreground:GetHeight() - 95)
    self.export_button:SetSize(100,20)
    self.export_button:SetText(Utils.L[locale]["button"]["export"])
    self.export_button:SetVisible(true)

    self.export_button.Click = function(sender, args)
        self:ShowExportWindow()
        self:ShowExport()
    end

    
    self.import_button = Turbine.UI.Lotro.Button()
    self.import_button:SetParent(self.foreground)
    self.import_button:SetPosition(0, self.foreground:GetHeight() - 70)
    self.import_button:SetSize(100,20)
    self.import_button:SetText(Utils.L[locale]["button"]["import"])
    self.import_button:SetVisible(true)

    self.import_button.Click = function(sender, args)
        self:ShowExportWindow()
        self:ShowImport()
    end
    

    self.collection_button = Turbine.UI.Lotro.Button()
    self.collection_button:SetParent(self.foreground)
    self.collection_button:SetPosition(0, self.foreground:GetHeight() - 35)
    self.collection_button:SetSize(100,20)
    self.collection_button:SetText(Utils.L[locale]["button"]["collection"])
    self.collection_button:SetVisible(true)

    self.collection_button.Click = function(sender, args)
        collection_Open()
    end

    self.accept_button = Turbine.UI.Lotro.Button()
    self.accept_button:SetParent(self.foreground)
    self.accept_button:SetPosition(self.foreground:GetWidth() - 212, self.foreground:GetHeight() - 35)
    self.accept_button:SetSize(80,20)
    self.accept_button:SetText(Utils.L[locale]["button"]["accept"])
    self.accept_button:SetVisible(true)

    self.accept_button.Click = function(sender, args)
        if self.selected_window_index ~= nil then
            self:SaveChanges()
        end

    end

    self.reload_button = Turbine.UI.Lotro.Button()
    self.reload_button:SetParent(self.foreground)
    self.reload_button:SetPosition(self.foreground:GetWidth() - 122, self.foreground:GetHeight() - 35)
    self.reload_button:SetSize(100,20)
    self.reload_button:SetText(Utils.L[locale]["button"]["save_reload"])
    self.reload_button:SetVisible(true)

    self.reload_button.Click = function(sender, args)
        if self.selected_window_index ~= nil then
            self:SaveChanges()
        end
        self:SetVisible(false)
        settings_Close(true)
    end

end


---------------------------------------------------------------------
--== window select ===--
---------------------------------------------------------------------

function Window:DeleteGroup(id, index, delete_children)

    ConfirmationWindow(self, 2, index, delete_children, id)

    -- if delete_children then
    --     local list = {}
    --     for i=1, table.getn(windowdata), 1 do
    --         if windowdata[i]["group"] == id then
    --             list[table.getn(list) + 1] = i
    --         end
    --     end
    --     for i=1, table.getn(list), 1 do
    --         RemoveWindow(list[i])
    --     end
    -- end

    -- RemoveGroup(index)
    -- self:FillWindows()

end

function Window:Resize(width, height)

    self:SetSize(width + OPTIONSWINDOWLEFT+10, height + 30)
    self.foreground:SetSize(self:GetWidth() - (OPTIONSWINDOWLEFT + OPTIONSLEFT) - 5, height)

    self.accept_button:SetPosition(self.foreground:GetWidth() - 212, self.foreground:GetHeight() - 35)
    self.reload_button:SetPosition(self.foreground:GetWidth() - 122, self.foreground:GetHeight() - 35)
    self.collection_button:SetPosition(0, self.foreground:GetHeight() - 35)
    self.track_target:SetPosition(120, self.foreground:GetHeight() - 95)
	self.track_group:SetPosition(120, self.foreground:GetHeight() - 70)
    self.import_button:SetPosition(0, self.foreground:GetHeight() - 70)
    self.export_button:SetPosition(0, self.foreground:GetHeight() - 95)

    self.windows:Resize(LISTBOXWIDTH, height - 6)
    self.trigger:Resize(LISTBOXWIDTH, height - 12)

end

function Window:RemoveWindowFromGroup(control)

    control.data["group"] = nil
            SaveSettings()
    self:FillWindows()

end

function Window:ClearWindows()

    self.windows:ClearItems()
    for index, control in ipairs(self.windows_controls) do
        control:Delete()
    end
    self.windows_controls = {}

    for index, control in ipairs(self.group_controls) do
        control:Delete()
    end
    self.group_controls = {}

end

--[[function Window:FillWindows()

    self:ClearWindows()

    self.windows:AddItem(self.windows_loaded_header)
    for i=1, table.getn(windowdata), 1 do
        self.windows_controls[i] = WindowItem(windowdata[i], LISTBOXWIDTH, i, self)

        if windowdata[i]["load"] then
            self.windows:AddItem(self.windows_controls[i])
        end
    end

    self.windows:AddItem(self.windows_notloaded_header)
    for index, control in ipairs(self.windows_controls) do
        if control.data["load"] == false then
            self.windows:AddItem(control)
        end
    end

    if table.getn(self.windows_controls) < 1 then
        self:EnableOptions(false)
    end

end]]

function Window:FillWindows()

    self:ClearWindows()

    for k,v in ipairs(windowdata["window_groups"]) do
        self.group_controls[k] = WindowGroupItem(v, LISTBOXWIDTH, k, self)
    end

    for i=1, table.getn(windowdata), 1 do
        local control =  WindowItem(windowdata[i], LISTBOXWIDTH, i, self)

        if windowdata[i]["group"] == nil then
            local index = table.getn(self.windows_controls) +1
            self.windows_controls[index] = control
        else
            for k,v in ipairs(windowdata["window_groups"]) do
                if v["id"] == windowdata[i]["group"] then
                    self.group_controls[ k ]:AddControl(control)
                end
            end
        end
    end

    self.windows:AddItem(self.windows_loaded_header)
    for key, control in ipairs(self.group_controls) do
        if control["data"]["load"] == true then
            self.windows:AddItem(control)
        end
    end
    for key, control in ipairs(self.windows_controls) do
        if control["data"]["load"] == true then
            self.windows:AddItem(control)
        end
    end

    self.windows:AddItem(self.windows_notloaded_header)
    for key, control in ipairs(self.group_controls) do
        if control["data"]["load"] == false then
            self.windows:AddItem(control)
        end
    end
    for key, control in ipairs(self.windows_controls) do
        if control["data"]["load"] == false then
            self.windows:AddItem(control)
        end
    end

    if table.getn(self.windows_controls) < 1 then
        self:EnableOptions(false)
    end

end

function Window:FilterWindows(text)

    self.windows:ClearItems()

    self.windows:AddItem(self.windows_loaded_header)
    for index, control in ipairs(self.group_controls) do
        if control.data["load"] then
            if string.find(string.lower(control.data["name"]), text) then
                self.windows:AddItem(control)
            else
                if control:FilterContent(text) then
                    self.windows:AddItem(control)
                end
            end
        end
    end
    for index, control in ipairs(self.windows_controls) do
        if control.data["load"] then
            if string.find(string.lower(control.data["name"]), text) then
                self.windows:AddItem(control)
            end
        end
    end

    self.windows:AddItem(self.windows_notloaded_header)
    for index, control in ipairs(self.group_controls) do
        if control.data["load"] == false then
            if string.find(string.lower(control.data["name"]), text) then
                self.windows:AddItem(control)
            else
                if control:FilterContent(text) then
                    self.windows:AddItem(control)
                end
            end
        end
    end
    for index, control in ipairs(self.windows_controls) do
        if not(control.data["load"]) then
            if string.find(string.lower(control.data["name"]), text) then
                self.windows:AddItem(control)
            end
        end
    end

end

function Window:ResetWindows(index)

    for i, control in ipairs(self.group_controls) do
        control:Reset(index)
    end

    for i, control in ipairs(self.windows_controls) do
        control:Reset(index)
    end

end

function Window:WindowLoadHasChanged()
    self:FilterWindows(self.windows.searchText)
    SaveSettings()
end

function Window:WindowSelectionChanged(index)

    self.selected_window_index = index
    self:ResetWindows(self.selected_window_index)
    self:FillTrigger()
    self:FillOptions()


    if index == nil then
        self:EnableOptions(false)
    else
        self:EnableOptions(true)
    end

end

function Window:NewWindowButtonPressed()

    self.new_window_menu:ShowMenu()

end

function Window:DeleteWindow(index)

    ConfirmationWindow(self, 1, index)

end

function Window:DuplicateWindow(index)

    DuplicateWindow(index)

    self:FillWindows()

    self.selected_window_index = nil
    self:FillTrigger()
    self:FillOptions()
    self:EnableOptions(false)

end

---------------------------------------------------------------------
--== options ===--
---------------------------------------------------------------------

function Window:EffectCollectionChanged(index)
    if self.trigger_window ~= nil then
        self.trigger_window:EffectCollectionChanged(index)
    end
end

function Window:ChatCollectionChanged(index)
    if self.trigger_window ~= nil then
        self.trigger_window:ChatCollectionChanged(index)
    end
end

function Window:SaveChanges()

    if self.selectType:GetSelection() == 1 then
        windowdata[self.selected_window_index]["type"] = "Bar_ListBox"
    elseif self.selectType:GetSelection() == 2 then
        windowdata[self.selected_window_index]["type"] = "Bar_Window"
    elseif self.selectType:GetSelection() == 3 then
        windowdata[self.selected_window_index]["type"] = "Icon_ListBox"
    elseif self.selectType:GetSelection() == 4 then
        windowdata[self.selected_window_index]["type"] = "Icon_Window"
    end

    local w = tonumber(self.width:GetText())
    local h = tonumber(self.height:GetText())
    local s = tonumber(self.spacing:GetText())
    local f = tonumber(self.frame_tb:GetText())
    local o = tonumber(self.opacity_tb:GetText())
    local o2 = tonumber(self.opacity2_tb:GetText())

    local nameChanged = false
    if self.name_tb:GetText() ~= windowdata[self.selected_window_index]["name"] then
        windowdata[self.selected_window_index]["name"] = self.name_tb:GetText()
        nameChanged = true
    end
    if (type(w) == "number") then
        windowdata[self.selected_window_index]["width"] = w
    end
    if (type(h) == "number") then
    windowdata[self.selected_window_index]["height"]= h
    end
    if (type(s) == "number") then
    windowdata[self.selected_window_index]["spacing"] = s
    end
    if (type(f) == "number") then
    windowdata[self.selected_window_index]["frame"] = f
    end
    if (type(o) == "number") then
    windowdata[self.selected_window_index]["opacity"] = o
    end
    if (type(o) == "number") then
        windowdata[self.selected_window_index]["opacity2"] = o2
    end


    windowdata[self.selected_window_index]["ascending"] = self.ascending:IsChecked()
    windowdata[self.selected_window_index]["orientation_horizontal"] = self.orientation_horizontal:IsChecked()
    windowdata[self.selected_window_index]["font"] = self.selectFont:GetSelection()

    local f_color_r, f_color_g, f_color_b = StringToColor(self.frame_color:GetText())
    local b_color_r, b_color_g, b_color_b = StringToColor(self.back_color:GetText())
    local ba_color_r, ba_color_g, ba_color_b = StringToColor(self.bar_color:GetText())

    if f_color_r ~= nil then
        windowdata[self.selected_window_index]["frame_color"]["R"] = f_color_r
        windowdata[self.selected_window_index]["frame_color"]["G"] = f_color_g
        windowdata[self.selected_window_index]["frame_color"]["B"] = f_color_b
    end

    if b_color_r ~= nil then
        windowdata[self.selected_window_index]["back_color"]["R"] = b_color_r
        windowdata[self.selected_window_index]["back_color"]["G"] = b_color_g
        windowdata[self.selected_window_index]["back_color"]["B"] = b_color_b
    end

    if ba_color_r ~= nil then
        windowdata[self.selected_window_index]["bar_color"]["R"] = ba_color_r
        windowdata[self.selected_window_index]["bar_color"]["G"] = ba_color_g
        windowdata[self.selected_window_index]["bar_color"]["B"] = ba_color_b
    end
    
    if nameChanged then
        SortWindows()
    end

    SaveSettings()

end

function Window:ShowExportWindow()

    if self.export_window == nil then
        self.export_window = ExportWindow(self)
    else
        --self.export_window:ShowExport(data)
    end

end

function Window:CloseExportWindow()
    self.export_window = nil
end

function Window:EmptyOptions()

    self.selectType:SetSelection(nil)
    self.name_tb:SetText("")
    self.width:SetText("")
    self.height:SetText("")
    self.spacing:SetText("")
    self.selectFont:SetSelection(nil)
    self.frame_tb:SetText("")
    self.opacity_tb:SetText("")
    self.opacity2_tb:SetText("")


end

function Window:FillOptions()

    self:EmptyOptions()

    if self.selected_window_index ~= nil then
        local data = windowdata[self.selected_window_index]
        
        if data["type"] == "Bar_ListBox" then
            self.selectType:SetSelection(1)
        elseif data["type"] == "Bar_Window" then
            self.selectType:SetSelection(2)
        elseif data["type"] == "Icon_ListBox" then
            self.selectType:SetSelection(3)
        elseif data["type"] == "Icon_Window" then
            self.selectType:SetSelection(4)
        else
            Turbine.Shell.WriteLine("SaveFile Corruped!")
        end
        self.name_tb:SetText(data["name"])
        self.width:SetText(data["width"])
        self.height:SetText(data["height"])
        self.spacing:SetText(data["spacing"])
        self.selectFont:SetSelection(data["font"])
        self.frame_tb:SetText(data["frame"])
        self.opacity_tb:SetText(data["opacity"])
        if data["opacity2"] ~= nil then
            self.opacity2_tb:SetText(data["opacity2"])
        else
            self.opacity2_tb:SetText("1")
        end
        self.ascending:SetChecked(data["ascending"])
        self.orientation_horizontal:SetChecked(data["orientation_horizontal"])
        self.frame_color:SetText(ColorToString(data["frame_color"]))
        self.bar_color:SetText(ColorToString(data["bar_color"]))
        self.back_color:SetText(ColorToString(data["back_color"]))
    end

end


---------------------------------------------------------------------
--== trigger select ===--
---------------------------------------------------------------------

function Window:CloseTriggerWindow()
    self.trigger_window = nil
end

function Window:AddGroupFromImport(name, w_data_list)

    local index = AddNewGroup(name)
    windowdata["window_groups"][index]["load"] = false
    for k,v in ipairs(w_data_list) do
        v["group"] = windowdata["window_groups"][index]["id"]
        self:AddWindowFromImport(v)
    end
    self:FillGroupContextMenu()
    self:FillWindows()
    self:WindowSelectionChanged(nil)

end

function Window:AddWindowFromImport(w_data)

    local index = table.getn(windowdata) + 1
    windowdata[index] = w_data
    windowdata[index]["id"] = windowdata["next_id"]
    windowdata["next_id"] = windowdata["next_id"] + 1
    self:FillWindows()
    self:WindowSelectionChanged(index)

    window_Create(index)

end

function Window:AddTriggerFromImport(t_data_list)

    if self.selected_window_index == nil then
        local index = AddNewWindow()
        self:FillWindows()
        self:WindowSelectionChanged(index)
    end

    for i=1, table.getn(t_data_list), 1 do

        if t_data_list[i]["sort_index"] >= windowdata[self.selected_window_index]["next_index"] then
            windowdata[self.selected_window_index]["next_index"] = t_data_list[i]["sort_index"] + 1
        end

        windowdata[self.selected_window_index][LIST_NAMES[t_data_list[i]["type"]]][table.getn(windowdata[self.selected_window_index][LIST_NAMES[t_data_list[i]["type"]]]) + 1] = t_data_list[i]

    end

    SaveSettings()
    self:FillTrigger()



end

function Window:NewTriggerButtonPressed()
    self.new_menu:ShowMenu()
end

function Window:MoveTriggerDown(current_item)

    local current_index = current_item.data["sort_index"]

    local list = {}

    for i,item in ipairs(self.trigger_controls) do 
        if item.data["sort_index"] > current_index then
            list[table.getn(list)+1] = item
        end
    end

    local swap_item
    local smallest_index = windowdata[self.selected_window_index]["next_index"]
    for i,item in ipairs(list) do 
        if item.data["sort_index"] < smallest_index then
            swap_item = item
            smallest_index = item.data["sort_index"]
        end
    end

    if smallest_index == 0 then return end

    current_item.data["sort_index"] = smallest_index
    swap_item.data["sort_index"] = current_index

    self:FillTrigger()
    SaveSettings()

end

function Window:MoveTriggerUp(current_item)

    local current_index = current_item.data["sort_index"]

    local list = {}

    for i,item in ipairs(self.trigger_controls) do 
        if item.data["sort_index"] < current_index then
            list[table.getn(list)+1] = item
        end
    end

    local swap_item
    local biggest_index = 0
    for i,item in ipairs(list) do 
        if item.data["sort_index"] > biggest_index then
            swap_item = item
            biggest_index = item.data["sort_index"]
        end
    end

    if biggest_index == 0 then
         return
    end


    current_item.data["sort_index"] = biggest_index
    swap_item.data["sort_index"] = current_index

    self:FillTrigger()
    SaveSettings()

end

function Window:DeleteTrigger(data)

    ConfirmationWindow(self, 0, data)
    -- trigger_Remove(data, windowdata[self.selected_window_index])
    -- self:FillTrigger()
    -- SaveSettings()
end

function Window:ShowTriggerWindow(data)

    if self.trigger_window == nil then
        self.trigger_window = TriggerWindow(data, self)
    else
        self.trigger_window:SetData(data)
    end

end

function Window:FilterTrigger(text)
    self.trigger:ClearItems()

    for index, control in ipairs(self.trigger_controls) do
        if string.find(string.lower(control.data["token"]), text) then
            self.trigger:AddItem(control)
        end
    end
end

function Window:ClearTrigger()

    self.trigger:ClearItems()
    for index, control in ipairs(self.trigger_controls) do
        control:Delete()
    end
    self.trigger_controls = {}

end

function Window:FillTrigger()

    self:ClearTrigger()

    if self.selected_window_index ~= nil and windowdata[ self.selected_window_index ] ~= nil then

        for i=1, table.getn(LIST_NAMES), 1 do
            for j=1, table.getn( windowdata[ self.selected_window_index ][ LIST_NAMES[i] ]), 1 do

                local index = table.getn(self.trigger_controls) + 1
                self.trigger_controls[index] = TriggerItem(windowdata[self.selected_window_index][LIST_NAMES[i]][j], LISTBOXWIDTH, self)
                self.trigger:AddItem(self.trigger_controls[index])

            end
        end

    end

    self.trigger:Sort(function(elem1,elem2) if elem1.data["sort_index"]<elem2.data["sort_index"] then return true end end)

end


---------------------------------------------------------------------
--=====--
---------------------------------------------------------------------
-- Group Item
---------------------------------------------------------------------
--=====--
---------------------------------------------------------------------


WindowGroupItem = class( Turbine.UI.Control )

function WindowGroupItem:Constructor(data, width, index, parent)
    Turbine.UI.Control.Constructor( self )

    self.parent = parent
    self.index = index
    self.data = data
    self.controls = {}

    self:SetSize(width, 52)
    
    self.background = Turbine.UI.Control()
    self.background:SetParent(self)
    self.background:SetSize(width, 50)
    self.background:SetBackColor(Turbine.UI.Color(0.2,0.2,0.2))
    self.background:SetVisible(true)
    self.background:SetMouseVisible(false)

    self.loadCheck =  Turbine.UI.Lotro.CheckBox()
	self.loadCheck:SetParent(self)
	self.loadCheck:SetMouseVisible(false)
	self.loadCheck:SetSize(26, 26)
	self.loadCheck:SetPosition(5,2)
	self.loadCheck:SetFont(Turbine.UI.Lotro.Font.Verdana14)
	self.loadCheck:SetText("")
	self.loadCheck:SetChecked(data["load"])
	self.loadCheck:SetZOrder(3)
	
	self.label =  Turbine.UI.Label()
	self.label:SetParent(self)
	self.label:SetMouseVisible(false)
	self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	self.label:SetSize(width-35, 26)
	self.label:SetPosition(33,2)
    self.label:SetFont(Turbine.UI.Lotro.Font.Verdana14)
    self.label:SetForeColor(Turbine.UI.Color.Orange)
	self.label:SetText(data["name"])
    self.label:SetZOrder(4)


    self.collapse = Turbine.UI.Button()
    self.collapse:SetParent(self.background)
    self.collapse:SetSize(15, 15)
    self.collapse:SetPosition(width-33, 7)
    self.collapse:SetBackColor(Turbine.UI.Color.Black)
    self.collapse:SetVisible(true)
    self.collapse:SetMouseVisible(true)
    if self.data["collapse"] == false then
        self.collapse:SetText("-")
    else
        self.collapse:SetText("+")
    end
    
    self.collapse.Click = function()
        self:CollapsedChanged()
    end
    self.collapse.MouseEnter = function()
        self.collapse:SetBackColor(Turbine.UI.Color(0.3,0.3,0.3))
    end

    self.collapse.MouseLeave = function()
        self.collapse:SetBackColor(Turbine.UI.Color.Black)
    end

    self.list = Turbine.UI.ListBox()
    self.list:SetParent(self)
    self.list:SetMouseVisible(false)
    self.list:SetSize(width- 12, 0)
    self.list:SetPosition(12,28)
    self.list:SetVisible(not(self.data["collapse"]))

    self.export_item = Turbine.UI.MenuItem( Utils.L[locale]["context_menu"]["export_group"], true )
    self.rename_item = Turbine.UI.MenuItem( Utils.L[locale]["context_menu"]["rename_group"], true )
    self.export_item = Turbine.UI.MenuItem( Utils.L[locale]["context_menu"]["export_group"], true )
    self.delete_item = Turbine.UI.MenuItem( Utils.L[locale]["context_menu"]["delete_group"], true )
    self.delete_item_with_children = Turbine.UI.MenuItem( Utils.L[locale]["context_menu"]["fulldelete_group"], true )

    self.menu = Turbine.UI.ContextMenu()
    self.menu_items = self.menu:GetItems()

    self.menu_items:Add( self.export_item )
    self.export_item.Click = function(sender, args)
        self.parent:ShowExport_Group(self.data["id"], self.data["name"])
    end

    self.menu_items:Add( self.rename_item )
    self.rename_item.Click = function(sender, args)
        GroupNameWindow(self.parent, self.index)
    end



    self.menu_items:Add( self.delete_item )
    self.delete_item.Click = function(sender, args)
        self.parent:DeleteGroup(self.data["id"], self.index, false)
    end

    self.menu_items:Add( self.delete_item_with_children )
    self.delete_item_with_children.Click = function(sender, args)
        self.parent:DeleteGroup(self.data["id"], self.index, true)
    end

    self.MouseEnter = function(sender, args)
        self.background:SetBackColor(Turbine.UI.Color(0.1,0.1,0.1))
    end

    self.MouseLeave = function(sender, args)
            self.background:SetBackColor(Turbine.UI.Color(0.2,0.2,0.2))
    end

    self.MouseClick = function(sender, args)
        if args.Button == Turbine.UI.MouseButton.Right then          
            self.menu:ShowMenu()
        end
    end

    self.MouseDoubleClick = function(sender, args)
        if args.Button == Turbine.UI.MouseButton.Left then          
            self:CollapsedChanged()
        end
    end

    self.loadCheck.CheckedChanged = function(sender, args)
        if self.loadCheck:IsChecked() then
            self.data["load"] = true
        else
            self.data["load"] = false
        end

        for index, control in ipairs(self.controls) do
            control:CheckedChanged(self.data["load"])
        end

        self.parent:WindowLoadHasChanged()
    end



end

function WindowGroupItem:CollapsedChanged()

    if self.data["collapse"] then
        self.data["collapse"] = false
        self.list:SetVisible(not(self.data["collapse"]))
        self.collapse:SetText("-")
        self:FilterContent(self.parent.windows.searchText)
        local height = self.list:GetItemCount()*32
        self:SetHeight(height + 32)
        self.background:SetHeight(height + 30)
        self.list:SetHeight(height)

        SaveSettings()
    else
        self.data["collapse"] = true
        self.list:SetVisible(not(self.data["collapse"]))
        self.collapse:SetText("+")
        self:SetHeight(32)
        self.background:SetHeight(30)
        SaveSettings()
    end

end

function WindowGroupItem:FilterContent(text)

    self.list:ClearItems()

    for index, control in ipairs(self.controls) do
        if string.find(string.lower(control.data["name"]), text) then
            self.list:AddItem(control)
        end
    end

    if self.list:GetItemCount() > 0 then
        local height = self.list:GetItemCount()*32

        if self.data["collapse"] == false then
            self:SetHeight(height + 32)
            self.background:SetHeight(height + 30)
            self.list:SetHeight(height)
        else
            self:SetHeight(32)
            self.background:SetHeight(30)
        end


        return true
    end

    for index, control in ipairs(self.controls) do
            self.list:AddItem(control)
    end

    return false

end

function WindowGroupItem:AddControl(control)

    local index = table.getn(self.controls) + 1
    self.controls[index] = control

    self.list:AddItem(control)

    local height = self.list:GetItemCount()*32

    if self.data["collapse"] == false then
        self:SetHeight(height + 32)
        self.background:SetHeight(height + 30)
        self.list:SetHeight(height)
    else
        self:SetHeight(32)
        self.background:SetHeight(30)
    end

end

function WindowGroupItem:Reset(index)

    for k,v in ipairs(self.controls) do

        v:Reset(index)

    end

end

function WindowGroupItem:Delete()

    for index, control in ipairs(self.controls) do
        control:Delete()
    end

    self:SetVisible(false)

end


---------------------------------------------------------------------
--=====--
---------------------------------------------------------------------
-- Window Item
---------------------------------------------------------------------
--=====--
---------------------------------------------------------------------


WindowItem = class( Turbine.UI.Control )

function WindowItem:Constructor(data, width, index, parent)
    Turbine.UI.Control.Constructor( self )

    self.parent = parent
    self.index = index
    self.data = data
    self.selected = false

    self:SetSize(width, 32)
    
    self.background = Turbine.UI.Control()
    self.background:SetParent(self)
    self.background:SetSize(width, 30)
    self.background:SetBackColor(Turbine.UI.Color.Black)
    self.background:SetVisible(true)
    self.background:SetMouseVisible(false)

    self.loadCheck =  Turbine.UI.Lotro.CheckBox()
	self.loadCheck:SetParent(self)
	self.loadCheck:SetMouseVisible(false)
	self.loadCheck:SetSize(26, 26)
	self.loadCheck:SetPosition(5,2)
	self.loadCheck:SetFont(Turbine.UI.Lotro.Font.Verdana14)
	self.loadCheck:SetText("")
	self.loadCheck:SetChecked(data["load"])
	self.loadCheck:SetZOrder(3)
	
    self.label =  Turbine.UI.Label()
	self.label:SetParent(self)
	self.label:SetMouseVisible(false)
	self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.label:SetSize(width-50, 26)
    self.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
	self.label:SetPosition(33,2)
	self.label:SetFont(Turbine.UI.Lotro.Font.Verdana14)
	self.label:SetText(data["name"])
    self.label:SetZOrder(4)

    self.delete_item = Turbine.UI.MenuItem( Utils.L[locale]["context_menu"]["delete_window"], true )
    self.duplicate_item = Turbine.UI.MenuItem( Utils.L[locale]["context_menu"]["duplicate_window"], true )
    self.export_item = Turbine.UI.MenuItem(Utils.L[locale]["context_menu"]["export_window"], true)


    self.menu = Turbine.UI.ContextMenu()
    self.menu_items = self.menu:GetItems()

    self.menu_items:Add( self.delete_item )
    self.menu_items:Add( self.duplicate_item )
    self.menu_items:Add( self.export_item )

    self.delete_item.Click = function(sender, args)
        self.parent:DeleteWindow(self.index)
    end

    self.duplicate_item.Click = function(sender, args)
        self.parent:DuplicateWindow(self.index)
    end

    self.export_item.Click = function(sender, args)

        self.parent:ShowExportWindow()
        self.parent.export_window:ShowExport_Window(self.data)

    end

    if self.data["group"] == nil then
        self.add_to_group_item = Turbine.UI.MenuItem( Utils.L[locale]["context_menu"]["add_to_group"], true )
        self.menu_items:Add(self.add_to_group_item)
        self.add_to_group_item.Click = function(sender, args)
            self.parent.addToGroupItem = self
            self.parent.group_selection:ShowMenu()
        end

    else
        self.remove_from_group_item = Turbine.UI.MenuItem( Utils.L[locale]["context_menu"]["remove_from_group"], true )
        self.menu_items:Add(self.remove_from_group_item)
        self.remove_from_group_item.Click = function(sender, args)
            self.parent:RemoveWindowFromGroup(self)
        end
    end

    self.MouseEnter = function(sender, args)
        if self.selected == false then
           self.background:SetBackColor(Turbine.UI.Color(0.3,0.3,0.3))
        end
    end

    self.MouseLeave = function(sender, args)
        if self.selected == false then
            self.background:SetBackColor(Turbine.UI.Color.Black)
        end
    end

    self.MouseClick = function(sender, args)
        if args.Button == Turbine.UI.MouseButton.Right then          
            self.menu:ShowMenu()
        elseif args.Button == Turbine.UI.MouseButton.Left then   

            if self.selected == false then
                self.parent:WindowSelectionChanged(self.index)
                self.selected = true
                self.background:SetBackColor(Turbine.UI.Color.Orange)

            end
            
        end
    end

    self.loadCheck.CheckedChanged = function(sender, args)
        if self.loadCheck:IsChecked() then
            self.data["load"] = true
            window_Create(self.index)       
        else
            self.data["load"] = false
            window_Close(self.index)
        end
        self.parent:WindowLoadHasChanged()
    end

end

function WindowItem:CheckedChanged(bool)
    self.loadCheck:SetChecked(bool)
end

function WindowItem:SetSelected()
    self.selected = true
    self.background:SetBackColor(Turbine.UI.Color.Orange)
end

function WindowItem:Reset(index)

    if index ~= self.index then
        self.background:SetBackColor(Turbine.UI.Color.Black)
        self.selected = false
    else
        self.selected = true
        self.background:SetBackColor(Turbine.UI.Color.Orange)
    end

end

function WindowItem:Delete()

    self:SetVisible(false)

end

---------------------------------------------------------------------
--=====--
---------------------------------------------------------------------
-- Trigger Item
---------------------------------------------------------------------
--=====--
---------------------------------------------------------------------
TRIGGERITEM_HEIGHT = 64

TriggerItem = class( Turbine.UI.Control )

function TriggerItem:Constructor(data, width, parent)
    Turbine.UI.Control.Constructor( self )

    self.data = data
    self.parent = parent

    self:SetSize(width, TRIGGERITEM_HEIGHT+2)
    
    self.background = Turbine.UI.Control()
    self.background:SetParent(self)
    self.background:SetSize(width, TRIGGERITEM_HEIGHT)
    self.background:SetBackColor(Turbine.UI.Color.Black)
    self.background:SetVisible(true)
    self.background:SetMouseVisible(false)

    self.icon = Turbine.UI.Control()
    self.icon:SetParent(self)
    self.icon:SetMouseVisible(false)
    if self.data["icon"] == nil then
        self.icon:SetSize(32,32)
        self.icon:SetBackColor(Turbine.UI.Color(0.1,0.1,0.1))
    else
        self.icon:SetSize(32,32)
        self.icon:SetBackground(tonumber(self.data["icon"]))
    end

    self.type =  Turbine.UI.Label()
	self.type:SetParent(self)
	self.type:SetMouseVisible(false)
	self.type:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
	self.type:SetSize(width-50, 14)
	self.type:SetPosition(34,2)
	self.type:SetFont(Turbine.UI.Lotro.Font.Verdana12)
	self.type:SetText(string.gsub(LIST_NAMES[data["type"]], "list_", ""))
    self.type:SetZOrder(4)
    self.type:SetForeColor(Turbine.UI.Color(0.4,0.4,0.4))
    self.type:SetFontStyle(Turbine.UI.FontStyle.Outline)

    self.timer =  Turbine.UI.Label()
	self.timer:SetParent(self)
	self.timer:SetMouseVisible(false)
	self.timer:SetTextAlignment(Turbine.UI.ContentAlignment.TopRight)
	self.timer:SetSize(width-50, 14)
	self.timer:SetPosition(34,2)
	self.timer:SetFont(Turbine.UI.Lotro.Font.Verdana12)
	self.timer:SetText(tostring(data["timer"]).."s")
    self.timer:SetZOrder(4)
    self.timer:SetForeColor(Turbine.UI.Color(0.4,0.4,0.4))
    self.timer:SetFontStyle(Turbine.UI.FontStyle.Outline)

    local text = data["text"]

    if data["description"] ~= nil and data["description"] ~= "" then
        text = data["description"]
    end

    self.text =  Turbine.UI.Label()
	self.text:SetParent(self)
	self.text:SetMouseVisible(false)
	self.text:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	self.text:SetSize(width-50, 14)
	self.text:SetPosition(34,16)
	self.text:SetFont(Turbine.UI.Lotro.Font.Verdana14)
	self.text:SetText(text)
    self.text:SetZOrder(4)
    self.text:SetFontStyle(Turbine.UI.FontStyle.Outline)
	
	self.token =  Turbine.UI.Label()
	self.token:SetParent(self)
	self.token:SetMouseVisible(false)
	self.token:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
	self.token:SetSize(width-13, 28)
	self.token:SetPosition(2,34)
	self.token:SetFont(Turbine.UI.Lotro.Font.Verdana12)
	self.token:SetText(data["token"])
    self.token:SetZOrder(4)
    self.token:SetForeColor(Turbine.UI.Color(0.8,0.8,0.8))
    self.token:SetFontStyle(Turbine.UI.FontStyle.Outline)

    self.item_name = Turbine.UI.MenuItem( self.data["token"], false )
    self.item_edit = Turbine.UI.MenuItem( Utils.L[locale]["context_menu"]["edit_trigger"], true )
    self.item_delete = Turbine.UI.MenuItem( Utils.L[locale]["context_menu"]["delete_trigger"], true )
    self.item_export = Turbine.UI.MenuItem( Utils.L[locale]["context_menu"]["export_trigger"], true )
    self.item_up = Turbine.UI.MenuItem( Utils.L[locale]["context_menu"]["up"], true )
    self.item_down = Turbine.UI.MenuItem( Utils.L[locale]["context_menu"]["down"], true )

    self.trigger_menu = Turbine.UI.ContextMenu()
    self.menu_items = self.trigger_menu:GetItems()

    self.menu_items:Add( self.item_name )
    self.menu_items:Add( self.item_edit )
    self.menu_items:Add( self.item_delete )
    self.menu_items:Add( self.item_export )
    self.menu_items:Add( self.item_up )
    self.menu_items:Add( self.item_down )

    self.item_edit.Click = function(sender, args)
        self.parent:ShowTriggerWindow(self.data)
    end

    self.item_delete.Click = function(sender, args)
        self.parent:DeleteTrigger(self.data)
    end

    self.item_export.Click = function(sender, args)
        self.parent:ShowExport_Trigger(self.data)
    end


    self.item_up.Click = function(sender, args)
        self.parent:MoveTriggerUp(self)
    end

    self.item_down.Click = function(sender, args)
        self.parent:MoveTriggerDown(self)
    end

    self.MouseEnter = function(sender, args)
        self.background:SetBackColor(Turbine.UI.Color(0.3,0.3,0.3))
    end

    self.MouseLeave = function(sender, args)
        self.background:SetBackColor(Turbine.UI.Color.Black)
    end

    self.MouseClick = function(sender, args)
        if args.Button == Turbine.UI.MouseButton.Right then          
            self.trigger_menu:ShowMenu()
        elseif args.Button == Turbine.UI.MouseButton.Left then   

        end
    end

end

function TriggerItem:Delete()

    self:SetVisible(false)
    self.icon:SetVisible(false)

end
