
Group = class( Turbine.UI.Window )

function Group:Constructor(data)
	Turbine.UI.Window.Constructor( self )

	self.data = data
	self.id = data["id"]

	self.left = 99999
	self.top = 99999
	self.right = 1
	self.bottom = 1

    self:SetMouseVisible(true)
    self:SetVisible(show_groups)

	self.frame = Turbine.UI.Window()
	self.frame:SetParent(self)
    self.frame:SetMouseVisible(false)
    self.frame:SetVisible(true)
    self.frame:SetBackColor(Turbine.UI.Color.Black)
	self.frame:SetOpacity(0.6)
	self.frame:SetZOrder(1)

	self.background = Turbine.UI.Control()
	self.background:SetParent(self.frame)
	self.background:SetPosition(2,2)
    self.background:SetMouseVisible(false)
    self.background:SetVisible(true)
    self.background:SetBackColor(Turbine.UI.Color.Orange)

	self.label_back = Turbine.UI.Window()
	self.label_back:SetParent(self)
    self.label_back:SetMouseVisible(false)
    self.label_back:SetVisible(true)
    --self.label_back:SetBackColor(Turbine.UI.Color.Orange)
	--self.label_back:SetOpacity(0.2)
	self.label_back:SetZOrder(1)

    self.move_label = Turbine.UI.Label()
	self.move_label:SetParent(self.label_back)
	self.move_label:SetPosition(2,2)
	self.move_label:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
	self.move_label:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    --self.move_label:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.move_label:SetText(self.data["name"])
    self.move_label:SetMouseVisible(false)
	self.move_label:SetForeColor(Turbine.UI.Color.Black)
	self.move_label:SetZOrder(2)
    
    self.MouseDown = function( sender, args )
		if args.Button == Turbine.UI.MouseButton.Left then
			self.dragging = true	
			self.dragStartX = args.X
			self.dragStartY = args.Y
			move_selection_Changed(self)
		end
	end
	
	self.MouseMove = function( sender, args )
		if self.dragging then
			local x,y = self:GetPosition()	
			local x_diff = ( args.X - self.dragStartX )
			local y_diff = ( args.Y - self.dragStartY )
			x = x + x_diff
			y = y + y_diff
			--self.data["left"],self.data["top"] = self:GetPosition()
			move_group(x_diff, y_diff)
			self:SetPosition( x, y )	
			move_selection_Moved()	
		end
	end
	
	self.MouseUp = function( sender, args )
		if args.Button == Turbine.UI.MouseButton.Left then
			self.dragging = false
			--self.data["left"],self.data["top"] = self:GetPosition()
				
			SaveSettings()
		end
	end
	
	for i=1, table.getn(windowdata), 1 do

		if windowdata[i]["group"] == self.id and windowdata[i]["load"]  then
	
			if windowdata[i]["left"] < self.left then
				if windowdata[i]["load"] == true then
					self.left = windows[i]:GetLeftForGroup()
				else
					self.left = windowdata[i]["left"]
				end
			end

			if windowdata[i]["top"] < self.top then
				if windowdata[i]["load"] == true then
					self.top = windows[i]:GetTopForGroup()
				else
					self.top = windowdata[i]["top"]
				end
			end

			local right =  windowdata[i]["left"] + windowdata[i]["width"]
			if right > self.right then
				if windowdata[i]["load"] == true then
					self.right = windows[i]:GetRightForGroup()
				else
					self.right = right
				end
			end

			local bottom =  windowdata[i]["top"] + windowdata[i]["height"] 
			if bottom > self.bottom then
				if windowdata[i]["load"] == true then
					self.bottom = windows[i]:GetBottomForGroup()
				else
					self.bottom = bottom
				end
			end

		end

	end

	self:SetPosition(self.left - 20, self.top - 20)
	--self.frame:SetPosition(self.left - 10, self.top - 10)

	self:SetSize(self.right-self.left + 40, self.bottom-self.top + 40)
	self.frame:SetSize(self.right-self.left + 40, self.bottom-self.top + 40)
	self.background:SetSize(self.right-self.left + 36, self.bottom-self.top + 36)
	self.label_back:SetSize(self.right-self.left + 40, self.bottom-self.top + 40)
	self.move_label:SetSize(self.right-self.left + 36, self.bottom-self.top + 36)


end

function Group:Show_Changed()
	self:SetVisible(show_groups)
end

function Group:LeftChanged(left)

	local x_diff = left - self:GetLeft()
	self:SetLeft(left)
	move_group(x_diff, 0)

end

function Group:TopChanged(top)

	local y_diff = top - self:GetTop() 
	self:SetTop(top)
	move_group(y_diff, 0)

end

function Group:ChildMoved()

	if move_selection ~= nil then

		self.left = 99999
		self.top = 99999
		self.right = 1
		self.bottom = 1
	

		for i=1, table.getn(windowdata), 1 do

			if windowdata[i]["group"] == self.id and windowdata[i]["load"] then
	
				if windowdata[i]["left"] < self.left then
					if windowdata[i]["load"] == true then
						self.left = windows[i]:GetLeftForGroup()
					else
						self.left = windowdata[i]["left"]
					end
				end
	
				if windowdata[i]["top"] < self.top then
					if windowdata[i]["load"] == true then
						self.top = windows[i]:GetTopForGroup()
					else
						self.top = windowdata[i]["top"]
					end
				end
	
				local right =  windowdata[i]["left"] + windowdata[i]["width"]
				if right > self.right then
					if windowdata[i]["load"] == true then
						self.right = windows[i]:GetRightForGroup()
					else
						self.right = right
					end
				end
	
				local bottom =  windowdata[i]["top"] + windowdata[i]["height"] 
				if bottom > self.bottom then
					if windowdata[i]["load"] == true then
						self.bottom = windows[i]:GetBottomForGroup()
					else
						self.bottom = bottom
					end
				end
	
			end
	
		end
	
		self:SetPosition(self.left - 20, self.top - 20)
		--self.frame:SetPosition(self.left - 10, self.top - 10)
	
		self:SetSize(self.right-self.left + 40, self.bottom-self.top + 40)
		self.frame:SetSize(self.right-self.left + 40, self.bottom-self.top + 40)
		self.background:SetSize(self.right-self.left + 36, self.bottom-self.top + 36)
		self.label_back:SetSize(self.right-self.left + 40, self.bottom-self.top + 40)
		self.move_label:SetSize(self.right-self.left + 36, self.bottom-self.top + 36)
	
	


	end

end